package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import freemarker.core.TemplateObject;
import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import javax.swing.*;
import java.time.temporal.Temporal;

public class CadastroServicoPage extends PageBase {

    By ClicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicarBotaoParametrizacao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");
    By clicarBotaoPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");
    By clicarBotaoServico = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[20]/ul/li[3]/ul/li[3]/span/span[3]");
    By clicarServico = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[20]/ul/li[3]/ul/li[3]/ul/li[3]/span/span[2]");
    By msgServico = By.xpath("//header[@class = 'zh-business-color-popup-header']//div[contains(text(),'Filtro')]");
    By msgEsperada = By.xpath("//*[contains(text(),'Unidade: ')]");
    By limpaFiltro = By.xpath("//*[@id='footer']/div[2]/ul/li");
    By filtroUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon = 'no-border search']");
    By inputUnidade = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");

    By btnAplicarFiltro = By.xpath("//section[@class = 'popup-container']//div[@id = 'footer']//span[contains(text(),'Aplicar filtro')]");
    By btnAdicionar = By.xpath("//*[@id='footer']/div[2]/ul/li/a/div");
    By buscaPadraoServico = By.xpath("//input[@class = 'editable selected-autocomplete ng-pristine ng-untouched ng-valid']");
    By servicoPadraoPlanejamento = By.xpath("//div[@class = 'list-items show-select']//span[text() = '00050 | ALMOÇO AUTOMAÇÃO']");
    By servicoPadraoFaturamento = By.xpath("//div[@class = 'list-items show-select']//span[text() = '00052 | FATURAMENTO AUTOMAÇÃO']");
    By servicoPadraoHospital = By.xpath("//div[@class = 'list-items show-select']//span[text() = '00053 | HOSPITAL AUTOMAÇÃO']");
    By campoCodigoServico = By.xpath("//input[@id ='CDSERVFILI' ]");
    By campoNmServico = By.xpath("//input[@id ='NMSERVICO' ]");
    By nmReduzido = By.xpath("//input[@name = 'NMSERVICOREDU']");
    By nmFantasia = By.xpath("//input[@name = 'NMFANTASSERV']");
    By grupServ = By.xpath("//*[@id='NMGRUPSERV']/span");
    By cdGrupo = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[1]");
    By comboServico = By.xpath("//div[@data-zh-id= '142611350924182009204304']//*[@tabindex= '0']");
    By servicoCorporativo = By.xpath("//ul[@class = 'list zh-new-select-list']//*[contains(text(),'(Corporativo) Restaurante')]");
    By servicoHospitalar = By.xpath("//ul[@class = 'list zh-new-select-list']//li[text() = 'Hospital']");
    By servicoFaturamento = By.xpath("//ul[@class = 'list zh-new-select-list']//li[text() = 'Faturamento']");
    By clicaServicoPlanejado = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[6]");
    By btnEditarServico = By.xpath("//li[@data-zh-id='142611350931005411024342']");

    By hrServico = By.xpath("//input[@name = 'HRINICATEN']");
    By hrEntrega = By.xpath("//input[@name = 'HRENTREGA']");
    By hrInicio = By.xpath("//input[@name = 'HRINICSERV']");
    By hrFim = By.xpath("//input[@name = 'HRFINASERV']");

    //Parâmetros Serviço
    By idOtimizador = By.xpath("//label[@for = 'zh-checkbox-IDOTIMIZADOR']");
    By idServicoAtivo = By.xpath("//label[@for = 'zh-checkbox-IDSERVATIV']");
    By idServPrinc = By.xpath("//label[@for = 'zh-checkbox-IDSERVPRINC']");
    By idCardDescentr = By.xpath("//label[@for = 'zh-checkbox-IDCARDDESCENTR']");
    By idUtRetPrat = By.xpath("//label[@for = 'zh-checkbox-IDUTRETIPRAT']");
    By idVlrVarData = By.xpath("//label[@for = 'zh-checkbox-IDVLRVARDATA']");
    By idServFatSep = By.xpath("//label[@for = 'zh-checkbox-IDSERVFATSEP']");
    By idConsComFat = By.xpath("//label[@for = 'zh-checkbox-IDCONSCOMFAT']");
    By idBloqIncProdRetPla = By.xpath("//label[@for = 'zh-checkbox-IDBLOQINCPRODRETIPLA']");
    By idBloqConsFixPer = By.xpath("//label[@for = 'zh-checkbox-IDBLOQCONFIXPER']");
    By msgBloqConsFixPer = By.xpath("//button[@class = 'zh-alert-button horizontal']/span[contains(text(),'Sim')]");
    By idServTran = By.xpath("//label[@for = 'zh-checkbox-IDSERVTRAN']");
    By idBaixaAutoEfetivacao = By.xpath("//label[@for='zh-checkbox-IDRETAUTOTRAN']//div[@class = 'zh-box mousetrap zh-ripple-effect']");


    //Utilizando para validar se os parâmetros já estão marcados.
    By inputOtimizador = By.xpath("//input[@id = 'zh-checkbox-IDOTIMIZADOR']");
    By inputServicoAtivo = By.xpath("//input[@id = 'zh-checkbox-IDSERVATIV']");
    By inputServicoPrincipal = By.xpath("//input[@id = 'zh-checkbox-IDSERVPRINC']");
    By inputServicoTransportado = By.xpath("//input[@id = 'zh-checkbox-IDSERVTRAN']");
    By inputUtRequisicaoPrato = By.xpath("//input[@id = 'zh-checkbox-IDUTRETIPRAT']");
    By inputServicoValorVariavel = By.xpath("//input[@id = 'zh-checkbox-IDVLRVARDATA']");
    By inputConsComFatPla = By.xpath("//input[@id = 'zh-checkbox-IDCONSCOMFAT']");
    By inputBloqincProdRetiPla = By.xpath("//input[@id = 'zh-checkbox-IDBLOQINCPRODRETIPLA']");
    By inputBloqConsFixPer = By.xpath("//input[@id = 'zh-checkbox-IDBLOQCONFIXPER']");
    By inputRetAutoTran = By.xpath("//input[@id = 'zh-checkbox-IDRETAUTOTRAN']");



    By prodFaturamento = By.xpath("//*[@id='NMPRODUTOFAT']/span");
    By campoProcurar = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaProduto = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[1]");
    By btnSalvar = By.xpath("//span[contains(text(),'Salvar')]");

    //Configuração do cardápio
    By selecionaServico = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[2]");
    By configPadrao = By.xpath("//*[contains(text(),'Configuração Padrão')]");
    By tipoPrato01 = By.xpath("//*[@id='grid-14261135092689446004118']/div[2]/div/div[1]/div[1]/span");
    By tipoprato02 = By.xpath("//*[@id='grid-14261135092689446004118']/div[2]/div/div[2]/div[1]/span");
    By tipoprato03 = By.xpath("//*[@id='grid-14261135092689446004118']/div[2]/div/div[3]/div[1]/span");
    By btnMover = By.xpath("//*[@id='footer']/div[2]/ul/li");
    By clicarComplemento = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[1]/div[3]/div");
    By adicionarComplemento = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[1]/div[3]/div/input");
    By ativaPratoOpcao = By.xpath("//span[@class = 'inline-checkbox-header zh-ripple-effect']");

    By msgEncontradaArroz = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[1]/div[2]");
    By msgEncontradaGuarnicao = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[2]/div[2]");
    By msgEncontradaSalada = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[3]/div[2]");


    By btnExportarConfiguracao = By.xpath("//li[@data-zh-id='142611350942048601641155']");
    By unidadeDestinoExportacao = By.xpath("//*[@id='CDFILIAL_EXPORT']");
    By selecionaDestinoExportacao = By.xpath("//*[@id='grid-9999']/div[2]/div/div/div[1]");
    By servicoDestinoExportacao = By.xpath("//div[@id = 'CDSERVFILI_DESTINO']");
    By btnExportaConfiguracaoCard = By.xpath("//li[@data-zh-id='142611350917403684741115']");
    By alertConfirmaExportacaoCard = By.xpath("//*[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");

    By marcaTipoPratoConfigOrig = By.xpath("//*[@id='grid-142611350924521686254045']/div[1]/div/div/div[1]");
    By btnExcluirConfiguracao = By.xpath("//li[@data-zh-id='14261135096163386184078']");

    By tipoPrato04 = By.xpath("//*[@id='grid-14261135092689446004118']/div[2]/div/div[6]/div[1]");
    By tipoPrato05 = By.xpath("//*[@id='grid-14261135092689446004118']/div[2]/div/div[5]/div[1]");
    By tipoPratoAcaoMover = By.xpath("//*[@id='grid-142611350924521686254045']/div[2]/div/div[3]/div[1]");
    By moverTipoPratoUp = By.xpath("//li[@data-zh-id='142611350921607122361149']");



    //Custo Padrão
    By custoPadrao = By.xpath("//*[contains(text(),'Custo Padrão')]");
    By btnAdicionaCusto = By.xpath("//div[@class = 'zh-footer-center']//li[@class = 'zh-ripple-effect']");
    By valorCustoPadrao = By.xpath("//input[@id = 'VRCUSTPADR']");
    By btnSalvarCusto = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By btnVoltar = By.xpath("//*[contains(text(),'Voltar')]");
    By clicaCustoPadrao = By.xpath("//*[@id='grid-14261135094802328464085']/div[2]/div/div[1]");
    By btnComensais = By.xpath("//*[contains(text(),'Comensais Estimados')]");
    By abaTiposDePrato = By.xpath("//*[contains(text(),'Tipos de Prato')]");
    By btnAdiconarCustoTipoPrato = By.xpath("//li[@data-zh-id='142611350924200544274100']");
    By clicaCampoTipoPrato = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOPRAT zh-text-align-left']");
    By tipoPratoGuarnicao = By.xpath("//span[text() = '02 | GUARNIÇÃO']");
    By valorCustoPadroaTP = By.xpath("//input[@id = 'VRCUSTPADRTP']");
    By btnConfirmarValor = By.xpath("//span[text() = 'Confirmar']");


    //Ponto de entrega
    By btnPontoEntrega = By.xpath("//*[contains(text(),'Ponto de Entrega por Cliente')]");
    By btnAddPontoEntrega = By.xpath("//div[@class = 'zh-footer-center']//li[@class = 'zh-ripple-effect']");
    By buscaCliente = By.xpath("//span[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By inputCliente = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaCliente = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By selecionaPontoEntrega = By.xpath("//div[@id = 'CDDESTFILI']");
    By checkPontoEntrega = By.xpath("//div[@class = 'body-content']//*[@data-zh-field-name='__CHECKBOX']");
    By btnConfirmaPonto = By.xpath("//section[@class = 'popup-container']//div[@id='footer']//*[contains(text(),'Ok')]");
    By btnVoltarInicio = By.xpath("//*[contains(text(),'Voltar')]");
    By validaCadastroPontoEntrega = By.xpath("//*[@id='grid-14261135099361095814194']/div[2]/div/div/div[2]/span");

    //Ação aba Faturamento
    By addServFatu = By.xpath("//div[@class = 'zh-footer-center']//*[@class = 'zh-ripple-effect']");
    By filtroServFatu = By.xpath("//div[@id = 'NMSERVICO']//*[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By informaServicoPesquisa = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaServFatu = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By salvaServFatu = By.xpath("//*[contains(text(),'Salvar')]");
    By retornaServicoSalvo = By.xpath("//*[@id='grid-14261135093940521174250']/div[2]/div/div/div[2]/span");
    By produtosParaFaturamento = By.xpath("//*[contains(text(),'Produtos para Faturamento')]");
    By addProdFaturamento = By.xpath("//div[@class = 'zh-footer-center']//*[@class = 'zh-ripple-effect']");
    By buscaProdFatu = By.xpath("//div[@id = 'NMPRODUTO']//*[@class = 'zh-icon zh-icon-search zh-icon-no-border']");
    By nomeProdFaturamento = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By retornaProdFat = By.xpath("//*[@id='grid-14261135093177801644268']/div[2]/div/div/div[2]/span");
    By btnSalvarAlteracoes = By.xpath("//span[text() = 'Salvar alterações']");
    By valPercentual = By.xpath("//input[@id='VRPERCENTUAL']");
    By btnConfimarProdFatu = By.xpath("//div[@id='footer']//*[text() = 'Confirmar']");

    //Manutenção Automática Custo Padrão
    By btnManutencaoAutomatica = By.xpath("//span[text() = 'Manutenção Automática']");
    By radioButonValor = By.xpath("//label[@for = 'radio-TIPODEST-V']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By radioButonPercentual = By.xpath("//label[@for = 'radio-TIPODEST-P']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By novoValorManutencaoCusto = By.xpath("//input[@id = 'NOVO_VALOR']");
    By campoAgrupFilialManutencaoCustoPadrao = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By limpaAgrupamentoManutencao = By.xpath("//span[@zh-icon ='no-border close-x']");
    By checkBoxTodasUnidadesManutencao = By.xpath("//label[@for = 'zh-checkbox-ALLNMFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoUnidadeManutencaoCustoPadrao = By.xpath("//div[@id = 'NMFILIAL']");
    By marcaUnidadeServicoFiltroManutencao = By.xpath("//div[@id = 'grid-9999']//div[@class = 'header']//div[@data-zh-field-name='__CHECKBOX']");
    By btnOkManutencaoCustoPadrao = By.xpath("//span[text() = 'Ok']");
    By confirmaMensagemAlerta = By.xpath("//*[@class = 'zh-alert-button']");
    By limpaDataInicial = By.xpath("//*[@id= 'DTINIC']//span[@zh-icon='no-border close-x']");
    By limpaDataFinal = By.xpath("//*[@id= 'DTFIN']//span[@zh-icon='no-border close-x']");
    By campoServicoManutencaoCustoPadrao = By.xpath("//div[@id = 'NMSERVICO']");
    By mesUnicialManutencaoCustoPadrao = By.xpath("//div[@id = 'DTINIC']");
    By selecionaMesInicialManutencaoCusto = By.xpath("//*[@class = 'month']//div[text() = 'Dez']");
    By mesFinalManutencaoCustoPadrao = By.xpath("//div[@id = 'DTFIN']");
    By selecionaMesFinalManutencaoCusto = By.xpath("//*[@class = 'month']//div[text() = 'Dez']");
    By selecionaMesInicialAtual = By.xpath("//div[@class = 'month']//div[text() = 'Jul']");
    By selecionaMesFinalAtual = By.xpath("//div[@class = 'month']//div[text() = 'Ago']");
    By limpaFiltroSelecionado = By.xpath("//div[@class = 'control-info']//span[@data-zh-icon='close-x no-border icon-white']");

    By checkBoxServicoPrincipal = By.xpath("//label[@for = 'zh-checkbox-IDSERVPRINC']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By acaoManutencaoCustoPadrao = By.xpath("//span[@class = 'current']");
    By btnAlterarManutencaoCusto = By.xpath("//li[text() = 'Alterar']");
    By btnIncluirManutencaoCusto = By.xpath("//li[text() = 'Incluir']");
    By checkBoxSobreporManutencaoCusto = By.xpath("//label[@for = 'zh-checkbox-SOBREPOR']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnFiltrarManutencaoCustoPadrao = By.xpath("//span[text() = 'Filtrar']");
    By checkBoxTodosServicosManutencao = By.xpath("//label[@for = 'zh-checkbox-ALLNMSERVICO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By selecionaServicoManutencaoCusto = By.xpath("//div[@id = 'grid-1340820356232431010116']//div[@class = 'header']//div[@data-zh-field-name='__CHECKBOX']");
    By excluirCustoPadrao = By.xpath("//li[@data-zh-id='13408203561689583503138']");
    By novoFiltroManucentao = By.xpath("//li[@data-zh-id='13408203563122642197484']");
    By clicaNovoValorServico_1 = By.xpath("//div[@id='grid-1340820356232431010116']/div[2]/div/div[1]/div[8]/div");
    By insereNovoValorServico_1 = By.xpath("//*[@id='grid-1340820356232431010116']/div[2]/div/div[1]/div[8]/div/input");
    By clicaNovoValorServico_2 = By.xpath("//*[@id='grid-1340820356232431010116']/div[2]/div/div[3]/div[8]/div");
    By insereNovoValorServico_2 = By.xpath("//*[@id='grid-1340820356232431010116']/div[2]/div/div[3]/div[8]/div/input");
    By clicaServicoExclusao_1 = By.xpath("//*[@id='grid-1340820356232431010116']/div[2]/div/div[4]/div[1]");
    By clicaServicoExclusao_2 = By.xpath("//*[@id='grid-1340820356232431010116']/div[2]/div/div[6]/div[1]");

    //comensais do serviço
    By QTCOMESTISEG = By.xpath("//*[@id='grid-142611350912285308094180']/div[2]/div/div[1]/div[2]/div");
    By QTCOMESTITER = By.xpath("//*[@id='grid-142611350912285308094180']/div[2]/div/div[2]/div[2]");
    By QTCOMESTIQUA = By.xpath("//*[@id='grid-142611350912285308094180']/div[2]/div/div[3]/div[2]");
    By QTCOMESTIQUI = By.xpath("//*[@id='grid-142611350912285308094180']/div[2]/div/div[4]/div[2]");
    By QTCOMESTISEX = By.xpath("//*[@id='grid-142611350912285308094180']/div[2]/div/div[5]/div[2]");
    By salvaComensais = By.xpath("//div[@class = 'zh-footer-right']/ul/li");

    //comensais ponto de entrega
    By clicarPontoEntrega = By.xpath("//*[@id='grid-14261135099361095814194']/div[2]/div/div/div[1]");
    By abaPontosDeEntrega = By.xpath("//a[text() = 'Pontos de Entrega']");
    By QTCOESTCSSEG = By.xpath("//input[@id = 'QTCOESTCSSEG']");
    By QTCOESTCSTER = By.xpath("//input[@id = 'QTCOESTCSTER']");
    By QTCOESTCSQUA = By.xpath("//input[@id = 'QTCOESTCSQUA']");
    By QTCOESTCSQUI = By.xpath("//input[@id = 'QTCOESTCSQUI']");
    By QTCOESTCSSEX = By.xpath("//input[@id = 'QTCOESTCSSEX']");
    By btnSalvaComensal = By.xpath("//li[@data-zh-id='142611350938497338184245']");

    By btnFaturamento = By.xpath("//a[contains(text(),'Faturamento')]");
    By clicarServicoPla = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[3]/div[1]");
    By btnEmbalagem = By.xpath("//a[contains(text(),'Embalagens')]");
    By servicoImportacaoEmbalagem = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[5]/div[1]");

    //Aba Aplicativos
    By servicoAplicativos = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[2]/div[1]");
    By btnAplicativos = By.xpath("//a[contains(text(),'Aplicativo')]");
    By btnEditarAplicativos = By.xpath("//li[@data-zh-id='1426113509546960012298']");
    By observacaoServico = By.xpath("//textarea[@id = 'DSOBSERVACAOSERVICO']");
    By diasLimiteSeguranca = By.xpath("//input[@id = 'NRLIMSEGPEDIDO']");
    By horaSergPedido = By.xpath("//input[@id = 'HRLIMSEGPEDIDO']");
    By descricaoServico = By.xpath("//textarea[@id = 'DSSERVICO']");
    By parametroDisponivelMyOrder = By.xpath("//label[@for = 'zh-checkbox-IDDISPOPEDIDOSERV']/div[1]");
    By parametroDisponivelMymenu = By.xpath("//label[@for = 'zh-checkbox-IDDISPONIVELMYMENU']/div[1]");
    By permiteReservaServico = By.xpath("//label[@for = 'zh-checkbox-IDRESERVASERVMYMENU']/div[1]");
    By visualizarCardDiasAntes = By.xpath("//input[@id = 'NRDIASANT']");
    By visualizarCardDiasApos = By.xpath("//input[@id = 'NRDIASPOS']");


    //Aba embalagem
    By clicaServicoEmbalagem = By.xpath("//*[@id='grid-14261135092187452014044']/div[2]/div/div[2]/div[1]");
    By filtroPontoEntrega = By.xpath("//div[@name = 'NMDESTFILI']//span[@zh-icon = 'no-border search']");
    By informaBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By nmPontoEntrega = By.xpath("//*[@id='grid-9000']/div[2]//div[@class = 'tr cell1']");
    By addEmbagalagens = By.xpath("//li[@data-zh-id='14261135092857170480870']");
    By buscaEmbalagem = By.xpath("//div[@name= 'NMCONTAINER']//span[@zh-icon= 'no-border search']");
    By selecionaEmbalagem = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[1]");
    By tipoPrato = By.xpath("//*[@id = 'NMTIPOPRAT']");
    By minimizaCampoBusca = By.xpath("//*[@class = 'float-action expandable fix-position-bottom opened']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By idPrato1 = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]/span");
    By idPrato2 = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]/span");
    By idprato3 = By.xpath("//*[@id='grid-9999']/div[2]/div/div[3]/div[1]/span");
    By idPratoSalada = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]/span");

    By validaEmbalagemExportada = By.xpath("//*[@id='grid-1426113509329969923789']/div[2]/div/div/div[3]/span");




    By clicaServico = By.xpath("//div[@id= 'grid-14261135092187452014044']//span[text() = '00012']");
    By clicaScroll = By.xpath("//div[@class = 'zh-tab-wrapper']//span[@class = 'icon-scroll-right zh-icon zh-icon-forward zh-icon-no-border']");
    By btnConfirmaEmba = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By btnSalvarEmbalagem = By.xpath("//div[@id = 'footer']//div[@class = 'zh-footer-right']");
    By clicarEmbalagem = By.xpath("//*[@id='grid-1426113509329969923789']/div[2]/div/div/div[2]");
    By validaPratoArroz = By.xpath("//*[@id='grid-1426113509228008623855']/div[2]/div/div[1]/div[2]/span");
    By validaPratoGuarnicao = By.xpath("//*[@id='grid-1426113509228008623855']/div[2]/div/div[2]/div[2]/span");
    By validaPratoSalada = By.xpath("//*[@id='grid-1426113509228008623855']/div[2]/div/div[3]/div[2]/span");
    By msgEncontradaImportacaoSalada = By.xpath("//*[@id='grid-1426113509228008623855']/div[2]/div/div/div[2]/span");
    By msgEncontrataImportacaoGuarnicao = By.xpath("//*[@id='grid-1426113509228008623855']/div[2]/div/div/div[2]/span");

    // Exportar Comensais
    By btnExportar = By.xpath("//li[@data-zh-id='1426113509158561807861']");
    By btnCalendario = By.xpath("//div[@id= 'PERIODO']");
    By dtInicial = By.xpath("//input[@id= 'PERIODO_START']");
    By dtFinal = By.xpath("//input[@id= 'PERIODO_END']");
    By confirPeriodo = By.xpath("//footer//div[@id= 'footer']//span[text() = 'OK']");
    By checkBoxInsereComensaisSemPrato = By.xpath("//label[@for='zh-checkbox-IDINSERIR']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnExportaComen = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//li[@data-zh-id='14261135093388478888870']");
    By btnCancelar = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-left']//li[@data-zh-id='14261135091750524679872']");

    //Importar Embalagens
    By importaEmbalagem = By.xpath("//span[text() = 'Importar Embalagens']");
    By filtraUnidade = By.xpath("//div[@data-zh-id='142611350922016638141214']//span[@zh-icon='no-border search']");
    By buscaServico = By.xpath("//div[@data-zh-id='142611350941176616811218']//span[@zh-icon='no-border search']");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[1]/span");
    By marcaServico = By.xpath("//div[@id = 'grid-9000']//span[text() = '00005']");
    By clicaEmbalagem = By.xpath("//div[@id= 'grid-1426113509329969923789']//div[@class = 'tr cell1']");
    By clicaEmbalagemSalada = By.xpath("//*[@id='grid-1426113509329969923789']/div[2]/div/div[2]/div[2]");
    By clicaEmbalagemPlastico = By.xpath("//*[@id='grid-1426113509329969923789']/div[2]/div/div[3]/div[2]");



    By nmDestFiliOri = By.xpath("//div[@name = 'NMDESTFILIORI']//span[@zh-icon = 'no-border search']");
    By botaoCancelar = By.xpath("//span[text() = 'Cancelar']");

    //Exporta Embalagem
    By btnAcoes = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By exportaEmbalagem = By.xpath("//span[text() = 'Exportar Embalagens']");
    By filtroFilial = By.xpath("//div[@data-zh-id='142611350921168531221227']//span[@zh-icon='no-border search']");
    By campoServico = By.xpath("//div[@id= 'NMSERVFILIDEST']");
    By defineServico = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]/span");
    By pontoEntregaDest = By.xpath("//div[@id = 'NMDESTFILIDEST']");
    By btnOk = By.xpath("//*[@class = 'popup-container']//span[text() = 'Ok']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By msgEsperadaExportacaoEmbalagem = By.xpath("//*[text() = 'DISTRIBUIÇÃO AUTOMÁTICA RECURSIVA']");


    By limpaFiltroTela = By.xpath("//div[@class = 'zh-footer-center']//li[@class = 'zh-ripple-effect']");
    By btnFiltro = By.xpath("//span[@data-zh-icon='filter no-border icon-white']");
    By servicoDestino = By.xpath("//div[@id= 'grid-14261135092187452014044']//span[text() = '00001']");
    By nmDestFiliDest = By.xpath("//div[@name = 'NMDESTFILIDEST']");
    By marcaPontoEntrega = By.xpath("//div[@class= 'tr cell1']//span[@data-ng-if='!row.__group']");

    // Apaga Embalagem
    By marcarEmbalagem = By.xpath("//*[@id='grid-1426113509329969923789']/div[1]/div/div/div[1]");
    By marcarEmbalagem01 = By.xpath("//*[@id='grid-1426113509329969923789']/div[2]/div/div[2]/div[1]/span");
    By btnExcluirEmbalagem = By.xpath("//li[@data-zh-id='1426113509360889069876']");
    By confirmaMensagem = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'Sim']");
    By validaExclusao = By.xpath("//*[@id='grid-14261135099361095814194']/div[2]/div/div/div/ng-include/p");



    //Altera comensais ponto de entrega
    By clicaPontoEntrega = By.xpath("//div[@id= 'grid-14261135099361095814194']//div[@class = 'tr cell1']");
    By pontosDeEntrega = By.xpath("//a[text() = 'Pontos de Entrega']");
    By qtComSeg = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[2]/div");
    By inputComSeg = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[2]/div/input");
    By qtComTer = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[3]");
    By inputComTer = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[3]/div/input");
    By qtComQuart = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[4]/div");
    By inputComQuart = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[4]/div/input");
    By qtComQuint = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[5]/div");
    By inputComQuint = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[5]/div/input");
    By qtComSex = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[6]/div");
    By inputComSex = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[6]/div/input");
    By qtComSab = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[7]/div");
    By inputComSab = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[7]/div/input");
    By qtComDom = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[7]/div");
    By inputComDom = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[7]/div/input");
    By qtComFeri = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[9]/div");
    By inputComFeri = By.xpath("//*[@id='grid-142611350933280525974195']/div[2]/div/div/div[9]/div/input");

    By btnSalvaAlteracao = By.xpath("//span[text() = 'Salvar alterações']");

    //Botão exclusão ponto entrega
    By btnExcluiPontoEntrega = By.xpath("//li[@data-zh-id='142611350929387074164241']");

    //Cadastra Turno
    By turnoComensais = By.xpath("//*[contains(text(),'Turnos e Comensais')]");
    By addTurno = By.xpath("//li[@data-zh-id='142611350929440953144166']");
    By nmTurno = By.xpath("//input[@id = 'NMTURNO1']");
    By qtdTurnoSegunda = By.xpath("//input[@id = 'QTCOMESTTSEG1']");
    By qtdTurnoTerca = By.xpath("//input[@id = 'QTCOMESTTTER1']");
    By qtdTurnoQuarta = By.xpath("//input[@id = 'QTCOMESTTQUA1']");
    By qtdTurnoQuinta = By.xpath("//input[@id = 'QTCOMESTTQUI1']");
    By qtdTurnoSexta = By.xpath("//input[@id = 'QTCOMESTTSEX1']");
    By nmSeguntoTuno = By.xpath("//input[@id = 'NMTURNO2']");
    By qtComeSegunda = By.xpath("//input[@id = 'QTCOMESTTSEG2']");
    By qtComeTerca = By.xpath("//input[@id = 'QTCOMESTTTER2']");
    By qtComeQuarta = By.xpath("//input[@id = 'QTCOMESTTQUA2']");
    By qtComeQuinta = By.xpath("//input[@id = 'QTCOMESTTQUI2']");
    By qtComeSexta = By.xpath("//input[@id = 'QTCOMESTTSEX2']");
    By salvarTurno = By.xpath("//li[@data-zh-id='142611350933124534244152']");
    By msgEncontradaTurno_1 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[2]/span");
    By msgEncontradaTurno_2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[2]/span");

    //Altera Comensais Turno
    By clicaNomeTurno1 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[2]/div");
    By novoNomeTurno1 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[2]/div/input");
    By clicaNomeTurno2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[2]/div");
    By novoNomeTurno2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[2]/div/input");
    By segundaPrimeioTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[3]/div");
    By tercaPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTTER']//div[@class = 'editable-content']");
    By quartaPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTQUA']//div[@class = 'editable-content']");
    By quintaPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTQUI']//div[@class = 'editable-content']");
    By sextaPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTSEX']//div[@class = 'editable-content']");
    By sabadoPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTSAB']//div[@class = 'editable-content']");
    By domingoPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTDOM']//div[@class = 'editable-content']");
    By feriadoPrimeioTurno = By.xpath("//div[@class = 'tr cell1 row-editing currentRow']//div[@data-zh-field-name='QTCOMESTTFER']//div[@class = 'editable-content']");

    By segundaSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[3]/div");
    By tercaSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[4]/div");
    By quartaSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[5]/div");
    By quintaSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[6]/div");
    By sextaSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[7]/div");
    By sabadoSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[8]/div");
    By domingoSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[9]/div");
    By feriadoSegundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[10]/div");

    //Apagando Turno

    By primeiroTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[1]");
    By segundoTurno = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[1]");
    By excluirTurno = By.xpath("//li[@data-zh-id='142611350921584524524172']");


    By qtdSegunda = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[3]/div/input");
    By qtdTerca = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[4]/div/input");
    By qtdQuarta = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[5]/div/input");
    By qtdQuinta = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[6]/div/input");
    By qtdSexta = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[1]/div[7]/div/input");
    By qtdSegunda2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[3]/div/input");
    By qtdTerça2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[4]/div/input");
    By qtdQuarta2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[5]/div/input");
    By qtdQuinta2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[6]/div/input");
    By qtdSexta2 = By.xpath("//*[@id='grid-142611350927812884014128']/div[2]/div/div[2]/div[7]/div/input");

    //Alterando/Apagando Produto de Faturamento

    By clicaPercentualProd1 = By.xpath("//div[@class = 'tr cell1']//div[@class = 'editable-content']");
    By clicaPercentualProd2 = By.xpath("//div[@class = 'tr cell2']//div[@class = 'editable-content']");
    By novoValorPercentualProd1 = By.xpath("//*[@id='grid-14261135093177801644268']/div[2]/div/div[1]/div[4]/div/input");
    By novoValorPercentualProd2 = By.xpath("//*[@id='grid-14261135093177801644268']/div[2]/div/div[2]/div[4]/div/input");
    By botaoOk = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'OK']");
    By validaExclusaoServFat = By.xpath("//*[@id='grid-14261135093940521174250']/div[2]/div/div/div/ng-include/p");

    By checkBoxServicoFaturamento = By.xpath("//*[@id='grid-14261135093940521174250']/div[2]/div/div/div[1]");
    By botaoExcluirServicoFatu = By.xpath("//li[@data-zh-id='142611350932168715274261']");
    By selcionaProduto2 = By.xpath("//*[@id='grid-14261135093177801644268']/div[2]/div/div[2]/div[1]");
    By selecionaProduto1 = By.xpath("//*[@id='grid-14261135093177801644268']/div[2]/div/div/div[1]");
    By botaoExcluirProdutoFat = By.xpath("//li[@data-zh-id='142611350914689836384289']");

    //Valida Exclusões
    By validaExclusaoTurno = By.xpath("//p[text() = 'Não há registros']");

    //Valida Alteração Produto Faturamento
    By novoProdutoFaturamento = By.xpath("//span[text() = 'OLEO DE CASTANHA DO BRASIL EMBALAGEM 1 LITRO']");


    public void ClicarMenu(){
        tempo();
        tempo();
        click(ClicaMenu);
        tempo();
        click(clicarBotaoParametrizacao);
        tempo();
        click(clicarBotaoPlanejamento);
        tempo();
        click(clicarBotaoServico);
        tempo();
        click(clicarServico);
        tempo();
        waitForElement(msgServico);
        tempo();

    }

    public void realizarFiltro(String unidade){
        if(unidade == "9999"){
            click(btnAplicarFiltro);
            tempo();
            waitForElement(msgEsperada);
            tempo();
        }else {
            click(limpaFiltro);
            click(filtroUnidade);
            tempo();
            click(inputUnidade);
            sendKeys(inputUnidade, unidade);
            tempo();
            click(clicaUnidade);
            tempo();
            click(btnAplicarFiltro);
            tempo();
            waitForElement(msgEsperada);
        }

    }

    public void insereInformacoes(String nomeReduzido, String nomeFantasia, String tipoServico ,String horaPreparo){
        click(btnAdicionar);
        tempo();
        click(buscaPadraoServico);
        tempo();
        if (tipoServico == "Planejamento") {
            click(servicoPadraoPlanejamento);
        }else if (tipoServico == "Hospitalar"){
            click(servicoPadraoHospital);
        }else {
            click(servicoPadraoFaturamento);
        }
        click(nmReduzido);
        sendKeys(nmReduzido, nomeReduzido);
        tempo();
        click(nmFantasia);
        sendKeys(nmFantasia, nomeFantasia);
        tempo();
        click(grupServ);
        click(cdGrupo);
        tempo();
        click(comboServico);
        tempo();
        if (tipoServico == "Planejamento") {
            click(servicoCorporativo);
            tempo();
            click(hrServico);
            sendKeys(hrServico, horaPreparo);
            tempo();
            click(hrEntrega);
            clearAndSendKeys(hrEntrega,"1200");
            tempo();
            click(hrInicio);
            clearAndSendKeys(hrInicio,"0700");
            click(hrFim);
            clearAndSendKeys(hrFim,"1400");
            tempo();
            click(idServicoAtivo);
        }else if (tipoServico == "Hospitalar"){
            click(servicoHospitalar);
            tempo();
            click(hrServico);
            tempo();
            sendKeys(hrServico, horaPreparo);
            tempo();
            click(hrEntrega);
            clearAndSendKeys(hrEntrega,"1200");
            tempo();
            click(hrInicio);
            clearAndSendKeys(hrInicio,"0700");
            click(hrFim);
            clearAndSendKeys(hrFim,"1400");
            tempo();
            click(idServicoAtivo);
        }else {
            click(servicoFaturamento);
        }
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void marcaParametrosServico(String tipoServico){

        if (tipoServico == "Planejamento") {
            click(clicaServicoPlanejado);
            tempo();
            click(btnEditarServico);
            tempo();
            if (!returnIfElementIsSelected(inputOtimizador)) {
                click(idOtimizador);
            } else if (!returnIfElementIsSelected(inputServicoAtivo)) {
                click(idServicoAtivo);
            } else if (!returnIfElementIsSelected(inputServicoPrincipal)) {
                click(idServPrinc);
            } else if (!returnIfElementIsSelected(inputServicoTransportado)) {
                click(idServTran);
            } else if (!returnIfElementIsSelected(inputUtRequisicaoPrato)) {
                click(idUtRetPrat);
            } else if (!returnIfElementIsSelected(inputServicoValorVariavel)) {
                click(idVlrVarData);
            } else if (!returnIfElementIsSelected(inputConsComFatPla)) {
                click(idConsComFat);
            } else if (!returnIfElementIsSelected(inputBloqincProdRetiPla)) {
                click(idBloqIncProdRetPla);
            } else if (!returnIfElementIsSelected(inputBloqConsFixPer)) {
                click(idBloqConsFixPer);
            } else if (!returnIfElementIsSelected(inputRetAutoTran)) {
                click(idBaixaAutoEfetivacao);
            }

        }else if (tipoServico == "Hospitalar") {

            if (!returnIfElementIsSelected(inputOtimizador)) {
                click(idOtimizador);
            } else if (!returnIfElementIsSelected(inputServicoAtivo)) {
                click(idServicoAtivo);
            } else if (!returnIfElementIsSelected(inputServicoPrincipal)) {
                click(idServPrinc);
            } else if (!returnIfElementIsSelected(inputServicoTransportado)) {
                click(idServTran);
            }
        }else{
            tempo();
            if (!returnIfElementIsSelected(inputServicoValorVariavel)) {
                click(idVlrVarData);
            }else if (!returnIfElementIsSelected(inputBloqincProdRetiPla)) {
                click(idBloqIncProdRetPla);
            }
        }
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void informaProdutoFatu(String nomeProduto){
        click(prodFaturamento);
        tempo();
        click(campoProcurar);
        tempo();
        sendKeys(campoProcurar, nomeProduto);
        tempo();
        click(clicaProduto);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void configuraCardapio(){
        tempo();
        click(selecionaServico);
        tempo();
        click(configPadrao);
        tempo();
        click(tipoPrato01);
        tempo();
        click(tipoprato02);
        tempo();
        click(tipoprato03);
        tempo();
        click(btnMover);
        tempo();
        click(clicarComplemento);
        click(adicionarComplemento);
        clearAndSendKeys(adicionarComplemento,"AUTOMAÇÃO");
        tempo();
        click(ativaPratoOpcao);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
    }

    public String configuracaoCardArroz(){
        return  getText(msgEncontradaArroz);

    }

    public String configuracaoCardGuarnicao(){
        return  getText(msgEncontradaGuarnicao);

    }

    public String configuracaoCardSalada(){
        return  getText(msgEncontradaSalada);

    }

    public void exportarConfiguracaoCardapio(String CDUNIDADEDEST, String CDSERVFILIDEST){
        tempo();
        click(selecionaServico);
        tempo();
        click(configPadrao);
        tempo();
        click(btnExportarConfiguracao);
        tempo();
        click(unidadeDestinoExportacao);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,CDUNIDADEDEST);
        tempo();
        click(selecionaDestinoExportacao);
        click(btnOk);
        tempo();
        click(servicoDestinoExportacao);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,CDSERVFILIDEST);
        tempo();
        click(selecionaDestinoExportacao);
        click(btnOk);
        tempo();
        click(btnExportaConfiguracaoCard);
        tempo();
        click(alertConfirmaExportacaoCard);
        tempo();
        click(confirmaMensagemAlerta);
        tempo();
    }

    public void editarConfiguracaoCard(){
        tempo();
        click(selecionaServico);
        tempo();
        click(configPadrao);
        tempo();
        click(tipoPrato04);
        click(tipoPrato05);
        click(btnMover);
        tempo();
        click(tipoPratoAcaoMover);
        click(moverTipoPratoUp);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();

    }

    public void excluirConfiguracaoServico(){
            tempo();
            click(selecionaServico);
            tempo();
            click(configPadrao);
            tempo();
            click(marcaTipoPratoConfigOrig);
            tempo();
            click(btnExcluirConfiguracao);
            tempo();
            click(alertConfirmaExportacaoCard);
            tempo();

    }

    public void custoPadrao(String valor){
        tempo();
        click(selecionaServico);
        tempo();
        click(custoPadrao);
        int i = 0;
        while (i < 3) {
            tempo();
            click(btnAdicionaCusto);
            tempo();
            click(valorCustoPadrao);
            tempo();
            sendKeys(valorCustoPadrao, valor);
            tempo();
            click(btnSalvarCusto);
            tempo();
            click(btnVoltar);
            tempo();
            i++;
        }
        tempo();
        click(clicaCustoPadrao);
        tempo();
        click(abaTiposDePrato);
        tempo();
        click(btnAdiconarCustoTipoPrato);
        tempo();
        click(clicaCampoTipoPrato);
        click(tipoPratoGuarnicao);
        click(valorCustoPadroaTP);
        clearAndSendKeys(valorCustoPadroaTP,"5,00");
        tempo();
        click(btnConfirmarValor);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();

    }

    public void manutencaoCustoPadrao(){
        click(clicaServico);
        tempo();
        click(custoPadrao);
        tempo();
        click(btnManutencaoAutomatica);
        tempo();
        click(campoAgrupFilialManutencaoCustoPadrao);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0000000002");
        tempo();
        click(selecionaBusca);
        click(checkBoxTodasUnidadesManutencao);
        click(campoUnidadeManutencaoCustoPadrao);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0002");
        tempo();
        click(marcaUnidadeServicoFiltroManutencao);
        click(btnOkManutencaoCustoPadrao);
        tempo();
        click(checkBoxTodosServicosManutencao);
        click(campoServicoManutencaoCustoPadrao);
        tempo();
        click(informaBusca);
        clearAndSendKeys(informaBusca,"00012");
        tempo();
        click(marcaUnidadeServicoFiltroManutencao);
        click(btnOkManutencaoCustoPadrao);
        tempo();
        click(mesUnicialManutencaoCustoPadrao);
        tempo();
        click(selecionaMesInicialManutencaoCusto);
        tempo();
        click(mesFinalManutencaoCustoPadrao);
        tempo();
        click(selecionaMesFinalManutencaoCusto);
        tempo();
        click(btnFiltrarManutencaoCustoPadrao);
        tempo();
        click(radioButonPercentual);
        click(novoValorManutencaoCusto);
        clearAndSendKeys(novoValorManutencaoCusto,"10");
        click(selecionaServicoManutencaoCusto);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(radioButonValor);
        click(novoValorManutencaoCusto);
        clearAndSendKeys(novoValorManutencaoCusto,"1,50");
        click(selecionaServicoManutencaoCusto);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(novoFiltroManucentao);
        tempo();
        click(limpaAgrupamentoManutencao);
        tempo();
        click(checkBoxTodasUnidadesManutencao);
        click(checkBoxTodosServicosManutencao);
        click(checkBoxServicoPrincipal);
        click(acaoManutencaoCustoPadrao);
        tempo();
        click(btnIncluirManutencaoCusto);
        tempo();
        duploClique(checkBoxSobreporManutencaoCusto);
        tempo();
        click(btnFiltrarManutencaoCustoPadrao);
        tempo();
        click(novoValorManutencaoCusto);
        clearAndSendKeys(novoValorManutencaoCusto,"2,30");
        click(selecionaServicoManutencaoCusto);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(radioButonPercentual);
        click(novoValorManutencaoCusto);
        clearAndSendKeys(novoValorManutencaoCusto,"20");
        click(selecionaServicoManutencaoCusto);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(novoFiltroManucentao);
        tempo();
        click(checkBoxServicoPrincipal);
        tempo();
        click(acaoManutencaoCustoPadrao);
        tempo();
        click(btnAlterarManutencaoCusto);
        click(btnFiltrarManutencaoCustoPadrao);
        tempo();
        click(clicaNovoValorServico_1);
        clearAndSendKeys(insereNovoValorServico_1,"3,50");
        click(clicaNovoValorServico_2);
        clearAndSendKeys(insereNovoValorServico_2,"4,20");
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(clicaServicoExclusao_1);
        click(clicaServicoExclusao_2);
        tempo();
        click(excluirCustoPadrao);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(limpaFiltroSelecionado);
        tempo();
        click(novoFiltroManucentao);
        tempo();
        click(acaoManutencaoCustoPadrao);
        tempo();
        click(btnIncluirManutencaoCusto);
        tempo();
        click(btnFiltrarManutencaoCustoPadrao);
        tempo();
        click(novoValorManutencaoCusto);
        clearAndSendKeys(novoValorManutencaoCusto,"10");
        click(selecionaServicoManutencaoCusto);
        tempo();
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void cadastraTurno(String NMTURNO1, String QTDSEG, String QTDTER, String QTDQUAR, String QTDQUIN, String QTDSEXT,
                              String NMTURNO2, String QTDSEG2, String QTDTER2, String QTDQUAR2, String QTDQUIN2, String QTDSEXT2){
        click(clicaServico);
        tempo();
        click(turnoComensais);
        tempo();
        click(addTurno);
        tempo();
        click(nmTurno);
        clearAndSendKeys(nmTurno, NMTURNO1);
        tempo();
        click(qtdTurnoSegunda);
        tempo();
        clearAndSendKeys(qtdTurnoSegunda,QTDSEG);
        click(qtdTurnoTerca);
        clearAndSendKeys(qtdTurnoTerca, QTDTER);
        click(qtdTurnoQuarta);
        clearAndSendKeys(qtdTurnoQuarta,QTDQUAR);
        click(qtdTurnoQuinta);
        clearAndSendKeys(qtdTurnoQuinta,QTDQUIN);
        click(qtdTurnoSexta);
        clearAndSendKeys(qtdTurnoSexta,QTDSEXT);
        click(nmSeguntoTuno);
        clearAndSendKeys(nmSeguntoTuno, NMTURNO2);
        click(qtComeSegunda);
        clearAndSendKeys(qtComeSegunda, QTDSEG2);
        click(qtComeTerca);
        clearAndSendKeys(qtComeTerca,QTDTER2);
        click(qtComeQuarta);
        clearAndSendKeys(qtComeQuarta,QTDQUAR2);
        click(qtComeQuinta);
        clearAndSendKeys(qtComeQuinta, QTDQUIN2);
        click(qtComeSexta);
        clearAndSendKeys(qtComeSexta,QTDSEXT2);
        click(salvarTurno);
        tempo();

    }

    public String validaCadastroTurnoManha(){
        return getText(msgEncontradaTurno_1);
    }

    public String validaCadastroTurnoTarde(){
        return getText(msgEncontradaTurno_2);
    }

    public void alteraComensaisTurno( String QTDSEG, String QTDTER, String QTDQUAR, String QTDQUIN, String QTDSEXT,
                                      String QTDSEG2, String QTDTER2, String QTDQUAR2, String QTDQUIN2, String QTDSEXT2){

        click(clicaServico);
        tempo();
        click(turnoComensais);
        tempo();
        click(clicaNomeTurno1);
        click(novoNomeTurno1);
        clearAndSendKeys(novoNomeTurno1,"ALMOÇO");
        click(segundaPrimeioTurno);
        tempo();
        clearAndSendKeys(qtdSegunda ,QTDSEG);
        click(tercaPrimeioTurno);
        clearAndSendKeys(qtdTerca, QTDTER);
        click(quartaPrimeioTurno);
        clearAndSendKeys(qtdQuarta,QTDQUAR);
        click(quintaPrimeioTurno);
        clearAndSendKeys(qtdQuinta,QTDQUIN);
        click(sextaPrimeioTurno);
        clearAndSendKeys(qtdSexta,QTDSEXT);
        tempo();
        click(clicaNomeTurno2);
        click(novoNomeTurno2);
        clearAndSendKeys(novoNomeTurno2,"JANTAR");
        tempo();
        click(segundaSegundoTurno);
        clearAndSendKeys(qtdSegunda2, QTDSEG2);
        click(tercaSegundoTurno);
        clearAndSendKeys(qtdTerça2,QTDTER2);
        click(quartaSegundoTurno);
        clearAndSendKeys(qtdQuarta2,QTDQUAR2);
        click(quintaSegundoTurno);
        clearAndSendKeys(qtdQuinta2, QTDQUIN2);
        click(sextaSegundoTurno);
        clearAndSendKeys(qtdSexta2,QTDSEXT2);
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void excluirTurno(){
        click(clicaServico);
        tempo();
        click(turnoComensais);
        tempo();
        click(segundoTurno);
        tempo();
        click(excluirTurno);
        tempo();
        click(confirmaMensagem);
        tempo();

    }


    public void informaComensais(String QTSEG, String QTTER, String QTQUA, String QTQUIN, String QTSEX){
        click(clicaServico);
        tempo();
        click(btnComensais);
        tempo();
        click(QTCOMESTISEG);
        tempo();
        informaComensais(QTCOMESTISEG,QTSEG);
        tempo();
        informaComensais(QTCOMESTITER,QTTER);
        tempo();
        informaComensais(QTCOMESTIQUA,QTQUA);
        tempo();
        informaComensais(QTCOMESTIQUI,QTQUIN);
        tempo();
        informaComensais(QTCOMESTISEX,QTSEX);
        tempo();
        click(salvaComensais);
        tempo();

    }

    public void alteraComensaisCliente(String QTSEG, String QTTER, String QTQUAR,
                                       String QTQUIN, String QTSEX){
        click(clicaServico);
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(clicaPontoEntrega);
        tempo();
        click(pontosDeEntrega);
        tempo();
        click(qtComSeg);
        clearAndSendKeys(inputComSeg, QTSEG);
        click(qtComTer);
        clearAndSendKeys(inputComTer,QTTER);
        click(qtComQuart);
        clearAndSendKeys(inputComQuart, QTQUAR);
        click(qtComQuint);
        clearAndSendKeys(inputComQuint,QTQUIN);
        click(qtComSex);
        clearAndSendKeys(inputComSex,QTSEX);
        click(btnSalvaAlteracao);
        click(btnSalvaAlteracao);
        click(confirmaMensagem);
        tempo();
        click(btnVoltarInicio);
        tempo();
    }

    public void exportaComensais(String DTINICIAL, String DTFINAL){
        tempo();
        click(clicaServico);
        tempo();
        click(btnComensais);
        tempo();
        click(btnExportar);
        tempo();
        preencheData(DTINICIAL, DTFINAL, dtInicial, dtFinal);
        tempo();
        click(btnExportaComen);
        tempo();
        click(checkBoxInsereComensaisSemPrato);
        tempo();
        click(btnExportaComen);
        tempo();
        click(btnCancelar);
        tempo();
        click(btnVoltarInicio);
        tempo();
    }

    public void cadastroPontoEntrega(String NMCLIENTE){
        click(clicaServico);
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(btnAddPontoEntrega);
        tempo();
        click(buscaCliente);
        tempo();
        sendKeys(inputCliente,NMCLIENTE);
        tempo();
        click(selecionaCliente);
        tempo();
        click(selecionaPontoEntrega);
        tempo();
        click(checkPontoEntrega);
        tempo();
        click(btnConfirmaPonto);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnVoltar);
        tempo();
    }

    public String msgEncontrada(){return getText(validaCadastroPontoEntrega);}

    public void apagaPontoEntrega(){
        click(clicaServico);
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(clicaPontoEntrega);
        tempo();
        click(btnExcluiPontoEntrega);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void comensaisPontoEntrega(String QTDCOESTCSSEG, String QTDCOMESTITER, String QTDCOMESTIQUA, String QTDCOESTCSQUI, String QTDCOMESTISEX){
       tempo();
       click(clicarPontoEntrega);
       tempo();
       click(abaPontosDeEntrega);
       tempo();
       informaComensais(QTCOESTCSSEG,QTDCOESTCSSEG);
       informaComensais(QTCOESTCSTER,QTDCOMESTITER);
       informaComensais(QTCOESTCSQUA,QTDCOMESTIQUA);
       informaComensais(QTCOESTCSQUI,QTDCOESTCSQUI);
       informaComensais(QTCOESTCSSEX,QTDCOMESTISEX);
       click(btnSalvaComensal);
       tempo();
       click(btnVoltar);
       tempo();
    }


    public void abaFaturamento(String NMSERVICO, String NMPRODUTOFATU, String VALPERCENTUAL){
        tempo();
        click(clicarServicoPla);
        tempo();
        click(btnFaturamento);
        tempo();
        click(addServFatu);
        tempo();
        click(filtroServFatu);
        tempo();
        click(informaServicoPesquisa);
        tempo();
        sendKeys(informaServicoPesquisa,NMSERVICO);
        tempo();
        click(clicaServFatu);
        tempo();
        click(salvaServFatu);
        tempo();
        Assert.assertEquals(validaServicoFat(), "00052","Validando se o serviço foi salvo corretamente: ");
        tempo();
        click(produtosParaFaturamento);
        tempo();
        click(addProdFaturamento);
        tempo();
        click(buscaProdFatu);
        tempo();
        click(nomeProdFaturamento);
        tempo();
        sendKeys(nomeProdFaturamento, NMPRODUTOFATU);
        tempo();
        click(clicaProduto);
        tempo();
        click(valPercentual);
        tempo();
        sendKeys(valPercentual, VALPERCENTUAL);
        tempo();
        click(btnConfimarProdFatu);
        tempo();
        click(btnSalvarAlteracoes);
        Assert.assertEquals(validaProdutoFat(),"1.01.1.1.01.001.00", "Validando se o produto foi salvo corretamente: ");
        tempo();

    }

    public String validaServicoFat(){
        return getText(retornaServicoSalvo);
    }

    public String validaProdutoFat(){
        return getText(retornaProdFat);
    }

    public void alterarProdutoFaturamento(String CDPRODFATU){
        click(clicarServicoPla);
        tempo();
        click(btnFaturamento);
        tempo();
        click(produtosParaFaturamento);
        tempo();
        click(clicaPercentualProd1 );
        clearAndSendKeys(novoValorPercentualProd1,"50");
        click(produtosParaFaturamento);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(botaoOk);
        tempo();
        click(addProdFaturamento);
        tempo();
        click(buscaProdFatu);
        tempo();
        click(nomeProdFaturamento);
        tempo();
        sendKeys(nomeProdFaturamento, CDPRODFATU);
        tempo();
        click(clicaProduto);
        tempo();
        click(valPercentual);
        tempo();
        sendKeys(valPercentual, "100");
        tempo();
        click(btnConfimarProdFatu);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(botaoOk);
        tempo();
        click(clicaPercentualProd2);
        tempo();
        clearAndSendKeys(novoValorPercentualProd2,"50");
        click(btnSalvarAlteracoes);
        tempo();
    }

    public void apagandoProdutoServicoFaturamento(){
        click(clicarServicoPla);
        tempo();
        click(btnFaturamento);
        tempo();
        click(checkBoxServicoFaturamento);
        tempo();
        click(botaoExcluirServicoFatu);
        tempo();
        click(confirmaMensagem);
        Assert.assertEquals(msgEsperadaExcluusaoServFat(),"Não há registros","Exclusão serviço aba faturamento: ");
        tempo();
        click(produtosParaFaturamento);
        tempo();
        click(selcionaProduto2);
        click(botaoExcluirProdutoFat);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(botaoOk);
        tempo();
        click(selecionaProduto1);
        click(botaoExcluirProdutoFat);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(confirmaMensagem);
        tempo();


    }

    public String msgEsperadaExcluusaoServFat(){
        return getText(validaExclusaoServFat);
    }

    public void abaEmbalagens(String TIPOEXPORTACAO,String NMPONTOENTREGA, String NMEMBALAGEM){
        click(clicaServicoEmbalagem);
        tempo();
        duploClique(clicaScroll);
        tempo();
        click(btnEmbalagem);
        tempo();
        if (TIPOEXPORTACAO == "Ponto de Entrega") {
            click(filtroPontoEntrega);
            tempo();
            click(informaBusca);
            tempo();
            sendKeys(informaBusca, NMPONTOENTREGA);
            tempo();
            click(nmPontoEntrega);
            tempo();
        }
        click(addEmbagalagens );
        tempo();
        click(buscaEmbalagem);
        tempo();
        click(informaBusca);
        tempo();
        sendKeys(informaBusca, NMEMBALAGEM);
        tempo();
        click(selecionaEmbalagem );
        tempo();
        click(tipoPrato);
        tempo();
        click(minimizaCampoBusca );
        tempo();
        click(idPrato1);
        tempo();
        click(idPrato2);
        tempo();
        click(idprato3);
        tempo();
        click(btnConfirmaEmba);
        tempo();
        click(btnSalvarEmbalagem);
        tempo();
        click(clicarEmbalagem);
        tempo();
        Assert.assertEquals(validaPratoArroz(),"ARROZ","Prato relacionado arroz: ");
        Assert.assertEquals(validaPratoGuarnicao(),"GUARNIÇÃO","Prato relacionado guarnição: ");
        Assert.assertEquals(validaPratoSalada(),"SALADA","Prato relacionado salada: ");
        tempo();
        click(btnVoltar);
        tempo();

    }

    public String validaPratoArroz(){
        return getText(validaPratoArroz);
    }

    public String validaPratoGuarnicao(){
        return getText(validaPratoGuarnicao);
    }

    public String validaPratoSalada(){
        return getText(validaPratoSalada);
    }

    public String validaImportacaoPratoSalada(){
        return getText(msgEncontradaImportacaoSalada);
    }

    public String validaImportacaoPratoGuarnicao(){
        return getText(msgEncontrataImportacaoGuarnicao);
    }

    public void exportarEmbalagem(String TIPOEXPORTACAO,String NMPONTOENTREGA,String CDFILIAL,String NMPONTOENTREGADEST) {
        tempo();
        click(clicaServicoEmbalagem);
        tempo();
        duploClique(clicaScroll);
        click(btnEmbalagem);
        tempo();
        if (TIPOEXPORTACAO == "Ponto de entrega") {
            click(filtroPontoEntrega);
            click(informaBusca);
            sendKeys(informaBusca, NMPONTOENTREGA);
            tempo();
            click(nmPontoEntrega);
        }
        click(btnAcoes);
        click(exportaEmbalagem);
        click(filtroFilial);
        click(informaBusca);
        if (TIPOEXPORTACAO == "Ponto de entrega") {
            sendKeys(informaBusca, CDFILIAL);
        }else{
            sendKeys(informaBusca, "9999");
        }
        tempo();
        click(clicaUnidade);
        click(campoServico);
        click(minimizaCampoBusca);
        click(defineServico);
        click(btnOk);
        if (TIPOEXPORTACAO == "Ponto de entrega") {
            click(nmDestFiliDest);
            click(minimizaCampoBusca);
            click(defineServico);
            click(btnOk);
        }
        tempo();
        click(btnConfirmar);
        tempo();
        click(btnVoltarInicio);
        tempo();
        click(btnFiltro);
        click(limpaFiltro);
        click(filtroUnidade);
        tempo();
        click(informaBusca);
        sendKeys(informaBusca, CDFILIAL);
        tempo();
        click(clicaUnidade);
        click(btnAplicarFiltro);
        tempo();
        click(servicoDestino);
        tempo();
        duploClique(clicaScroll);
        click(btnEmbalagem);
        tempo();

        if (TIPOEXPORTACAO == "Ponto de entrega"){
        click(filtroPontoEntrega);
        click(informaBusca);
        sendKeys(informaBusca, NMPONTOENTREGADEST);
        click(nmPontoEntrega);
        tempo();
    }
        Assert.assertEquals(validaEmbalagemExportada(),"DISTRIBUIÇÃO AUTOMÁTICA","Embalagem exportada para a unidade 0003: ");
        click(clicarEmbalagem);
        tempo();
        Assert.assertEquals(validaPratoArroz(),"ARROZ","Prato relacionado arroz: ");
        Assert.assertEquals(validaPratoGuarnicao(),"GUARNIÇÃO","Prato relacionado guarnição: ");
        Assert.assertEquals(validaPratoSalada(),"SALADA","Prato relacionado salada: ");
        tempo();
        click(btnVoltar);
        tempo();
    }

    public String validaEmbalagemExportada(){
        return getText(validaEmbalagemExportada);
    }

    public void excluirEmbalagemPontoEntrega(String TIPOEXCLUSAO, String NMPONTOENTREGA){
        tempo();
        click(clicaServicoEmbalagem);
        tempo();
        duploClique(clicaScroll);
        click(btnEmbalagem);
        if (TIPOEXCLUSAO == "PontoEntrega") {
            click(filtroPontoEntrega);
            click(informaBusca);
            sendKeys(informaBusca, NMPONTOENTREGA);
            tempo();
            click(nmPontoEntrega);
        }
        tempo();
        click(marcarEmbalagem);
        click(btnExcluirEmbalagem);
        click(confirmaMensagem);
        tempo();

    }


    public void adicionaInformacaoAplicativos(){
        click(servicoAplicativos);
        tempo();
        click(btnAplicativos);
        tempo();
        click(btnEditarAplicativos);
        tempo();
        click(observacaoServico);
        clearAndSendKeys(observacaoServico,"TEXTO AUTOMAÇÃO SERVIÇO");
        tempo();
        click(diasLimiteSeguranca);
        clearAndSendKeys(diasLimiteSeguranca,"5");
        click(horaSergPedido);
        clearAndSendKeys(horaSergPedido,"0500");
        click(descricaoServico);
        clearAndSendKeys(descricaoServico,"Serviço almoço automatizado");
        click(parametroDisponivelMyOrder);
        click(parametroDisponivelMymenu);
        click(permiteReservaServico);
        click(visualizarCardDiasAntes);
        clearAndSendKeys(visualizarCardDiasAntes,"3");
        click(visualizarCardDiasApos);
        clearAndSendKeys(visualizarCardDiasApos,"4");
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void editarExcluirInformacaoAplicativos(String tipoAcao){
        click(servicoAplicativos);
        tempo();
        click(btnAplicativos);
        tempo();
        click(btnEditarAplicativos);
        tempo();
        if (tipoAcao == "Editar"){
        click(observacaoServico);
        clearAndSendKeys(observacaoServico,"Serviço teste automação teknisa!!!!!");
        tempo();
        click(diasLimiteSeguranca);
        clearAndSendKeys(diasLimiteSeguranca,"1");
        click(horaSergPedido);
        clearAndSendKeys(horaSergPedido,"0720");
        click(descricaoServico);
        clearAndSendKeys(descricaoServico,"Teste automação aplicativos!!!!!!");
        click(parametroDisponivelMyOrder);
        click(parametroDisponivelMymenu);
        click(permiteReservaServico);
        click(visualizarCardDiasAntes);
        clearAndSendKeys(visualizarCardDiasAntes,"6");
        click(visualizarCardDiasApos);
        clearAndSendKeys(visualizarCardDiasApos,"6");
        tempo();
        }else{
            click(observacaoServico);
            clear(observacaoServico);
            tempo();
            click(diasLimiteSeguranca);
            clear(diasLimiteSeguranca);
            click(horaSergPedido);
            clear(horaSergPedido);
            click(descricaoServico);
            clear(descricaoServico);
            click(parametroDisponivelMyOrder);
            click(parametroDisponivelMymenu);
            click(permiteReservaServico);
            click(visualizarCardDiasAntes);
            clear(visualizarCardDiasAntes);
            click(visualizarCardDiasAntes);
            tempo();
        }

        click(btnSalvar);
        tempo();

    }

    public void exportarEmbalagem(String CDFILIAL){
        click(clicaServico);
        click(clicaScroll);
        click(clicaScroll);
        click(btnEmbalagem);
        click(btnAcoes);
        click(exportaEmbalagem);
        tempo();
        click(filtroFilial);
        tempo();
        click(informaBusca);
        tempo();
        sendKeys(informaBusca, CDFILIAL);
        tempo();
        click(clicaUnidade);
        tempo();
        click(campoServico);
        tempo();
        click(minimizaCampoBusca);
        tempo();
        click(defineServico);
        tempo();
        click(btnOk);
        tempo();
        click(btnConfirmar);
        tempo();
        click(btnVoltarInicio);
        click(btnFiltro);
        tempo();
        click(limpaFiltroTela);
        tempo();
        click(filtroUnidade);
        tempo();
        click(inputUnidade);
        tempo();
        sendKeys(inputUnidade,CDFILIAL);
        tempo();
        click(clicaUnidade);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(servicoDestino);
        tempo();
        click(clicaScroll);
        tempo();
        click(clicaScroll);
        tempo();
        click(btnEmbalagem);
        tempo();
        click(filtroPontoEntrega);
        tempo();
        click(minimizaCampoBusca);
        tempo();
        click(selecionaBusca);
        tempo();


    }

    public String validaExportacaoEmbalagem(){
        tempo();
       return getText(msgEsperadaExportacaoEmbalagem);
    }

    public void importaEmbalagem(String CDUNIDADE, String TIPOIMPORTACAO){
        click(servicoImportacaoEmbalagem);
        tempo();
        duploClique(clicaScroll);
        click(btnEmbalagem);
        click(btnAcoes);
        tempo();
        click(importaEmbalagem);
        click(filtraUnidade);
        click(informaBusca);
        sendKeys(informaBusca, CDUNIDADE);
        tempo();
        click(selecionaBusca);
        click(buscaServico);
        click(minimizaCampoBusca);
        click(marcaServico);
        tempo();
        if (TIPOIMPORTACAO == "PontoEntrega") {
            click(nmDestFiliOri);
            click(minimizaCampoBusca);
            click(nmPontoEntrega);
        }
        tempo();
        click(btnConfirmar);
        tempo();
        click(clicaEmbalagem);
        tempo();
        Assert.assertEquals(validaPratoArroz(),"ARROZ","Validando se o prato arroz foi importado corretamente: ");
        click(btnVoltarInicio);
        tempo();
        click(clicaEmbalagemSalada);
        tempo();
        Assert.assertEquals(validaImportacaoPratoSalada(),"SALADA","Validando se o prato salada foi importado corretamente: ");
        tempo();
        click(btnVoltarInicio);
        tempo();
        click(clicaEmbalagemPlastico);
        tempo();
        Assert.assertEquals(validaImportacaoPratoGuarnicao(),"GUARNIÇÃO","Validando se o prato guarnição foi importado corretamente: ");
        tempo();
        for (int i = 0; i < 2; i++) {
            click(btnVoltarInicio);
        }
        tempo();

    }

    public String validaExclusao(){
        tempo();
        return getText(validaExclusao);
    }

    public String validaExclusaoTurno(){
            return getText(validaExclusaoTurno);
    }

    public String validaAlteracaoProdutoFaturamento(){
        return getText(novoProdutoFaturamento);
    }


    }
