package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class GrupoServicosPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaGrupoServicos = By.xpath("//span[text() = 'Grupo de Serviços']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurarTelaInicial = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By campoCodigo = By.id("CDGRUPSERV");
    By campoNome = By.id("NMGRUPSERV");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"9743825571937903742737\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"9743825571294891131738\"]//div[@class=\"zh-validation\"]/span");

    By checkBoxGrupoLinha1 = By.xpath("//div[@id=\"grid-974382557381890778736\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By codigoGrupoLinha1 = By.xpath("//div[@id=\"grid-974382557381890778736\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDGRUPSERV\"]/span");
    By nomeGrupoLinha1 = By.xpath("//div[@id=\"grid-974382557381890778736\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMGRUPSERV\"]/span");

    By abaServico = By.xpath("//div[@class=\"zh-tab-wrapper\"]//label[@class=\"zh-tab-cell\"]//a[text() = 'Serviços']");
    By codigoServicoLinha1 = By.xpath("//div[@id=\"grid-9743825574259211496414\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDSERVFILI\"]/span");
    By nomeServicoLinha1 = By.xpath("//div[@id=\"grid-9743825574259211496414\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMSERVICO\"]/span");
    By campoOrdenacaoTransporteServicoLinha1 = By.xpath("//div[@id=\"grid-9743825574259211496414\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRORDSERVTRANSP\"]//div[@class=\"editable-content\"]");
    By inputOrdenacaoTransporteServicoLinha1 = By.xpath("//div[@id=\"grid-9743825574259211496414\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRORDSERVTRANSP\"]//div[@class=\"editable-content\"]/input");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemNenhumRegistroEncontrado = By.xpath("//div[@id=\"grid-974382557381890778736\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Grupo de Serviços");
        click(opcaoTelaGrupoServicos);
    }

    public void adicionarGrupo() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "10");
        sendKeys(campoNome, "VENDAS");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso, após adicionar um novo grupo de serviço");

        refresh();
        preencherCampoProcurarTelaInicial("010");
        //dados do grupo adicionado
        String codigo = getText(codigoGrupoLinha1);
        String nome = getText(nomeGrupoLinha1);

        Assert.assertEquals(codigo, "010", "Verificação do código");
        Assert.assertEquals(nome, "VENDAS", "Verificação do nome");
    }

    public void excluirGrupo() {
        tempo();
        preencherCampoProcurarTelaInicial("010");
        click(checkBoxGrupoLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, "Deletar o(s) registro(s)?", "Verificação mensagem alerta da exclusão");
        click(botaoSim);
        tempo();

        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Excluído com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");

        mensagem = getText(mensagemNenhumRegistroEncontrado);
        String mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no grid da lista de grupos informando que nenhum registro foi encontrado");
    }

    public void editarNomeGrupoServico() {
        preencherCampoProcurarTelaInicial("005");
        alterarValorDoCampo(nomeGrupoLinha1, "DISPENSA");
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso, após alterar o nome do grupo de serviço");

        refresh();
        preencherCampoProcurarTelaInicial("005");
        String nome = getText(nomeGrupoLinha1);
        Assert.assertEquals(nome, "DISPENSA", "Verificar se o nome do grupo de serviços foi alterado corretamente");

        alterarValorDoCampo(nomeGrupoLinha1, "ENTREGAS");
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();
        nome = getText(nomeGrupoLinha1);
        Assert.assertEquals(nome, "ENTREGAS", "Verificar se a alteração do nome do grupo de serviço, para o nome que estava no início do teste foi feita com sucesso");
    }

    public void verificarOrdenacaoTranspAbaServicos() {
        preencherCampoProcurarTelaInicial("006");
        String nomeGrupo = getText(nomeGrupoLinha1);
        Assert.assertEquals(nomeGrupo, "TRANSP.", "Verificar o nome do grupo de serviço que será acessado para verficar a aba serviços");

        click(codigoGrupoLinha1);
        tempo();
        click(abaServico);
        String mensagem = "";
        String valorOrdenacaoTransporte = "";

        alterarValorDoCampo(campoOrdenacaoTransporteServicoLinha1, "LETRAS");
        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Valor deve ser um número", "Verificar mensagem exibida no canto superior direito, após tentar adicionar letras ao campo ordenação de transporte");
        tempo();

        alterarValorDoCampo(campoOrdenacaoTransporteServicoLinha1, "/*");
        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Valor deve ser um número", "Verificar mensagem exibida no canto superior direito, após tentar adicionar caracteres especiais ao campo ordenação de transporte");
        tempo();

        alterarValorDoCampo(campoOrdenacaoTransporteServicoLinha1, "0");
        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Valor deve ser um número", "Verificar mensagem exibida no canto superior direito, após tentar adicionar 0 ao campo ordenação de transporte");
        tempo();

        alterarValorDoCampo(campoOrdenacaoTransporteServicoLinha1, "7");
        click(botaoSalvarAlteracoes);
        tempo();
        tempo();
        valorOrdenacaoTransporte = driver.findElement(inputOrdenacaoTransporteServicoLinha1).getAttribute("value");
        Assert.assertEquals(valorOrdenacaoTransporte, "7", "Verificar se após adicionar um número maior que 0 ao campo ordenação transporte o mesmo é salvo com sucesso");

        alterarValorDoCampo(campoOrdenacaoTransporteServicoLinha1, "");
        click(botaoSalvarAlteracoes);
        tempo();
        tempo();
        valorOrdenacaoTransporte = driver.findElement(inputOrdenacaoTransporteServicoLinha1).getAttribute("value");
        Assert.assertEquals(valorOrdenacaoTransporte, "", "Verificar se é possível deixar o campo ordenação transporte com valor vazio");

        String codigoServico = getText(codigoServicoLinha1);
        String nomeServico = getText(nomeServicoLinha1);
        Assert.assertEquals(codigoServico, "00005", "Verificar o código do serviço que foram feitos os testes no campo ordenação de trasporte");
        Assert.assertEquals(nomeServico, "REFEIÇÕES TRANSPORTADAS", "Verificar o nome do serviço que foram feitos os testes no campo ordenação de trasporte");
    }

    public void tentarExcluirGrupoComRegistroFilhos() {
        preencherCampoProcurarTelaInicial("001");
        click(checkBoxGrupoLinha1);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o grupo de serviços");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que o grupo de serviços, pssuí registros filhos");
        click(botaoOk);
        tempo();
        click(checkBoxGrupoLinha1);
        click(codigoGrupoLinha1);
    }

    public void tentarAddCodigoExistente() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "VENDAS");
        click(botaoSalvar);

        //mensagem alerta de código já existente
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentar adicionar um código já existente");
        click(botaoOk);
    }

    public void camposObrigatorios() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrada no código e nome
        String mensagemCodigo = getText(mensagemObrigatorioCodigo);
        String mensagemNome = getText(mensagemObrigatorioNome);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemCodigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo código");
        Assert.assertEquals(mensagemNome, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo nome");
        click(botaoCancelar);
    }

    private void alterarValorDoCampo(By campo, String valor) {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempoParaAguardarTelaInicial();
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            tempo();
            click(botaoPesquisar);
        }
        clearAndSendKeys(campoProcurarTelaInicial, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }


}
