package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MapaDeProducaoPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By cClicaCardapio = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[2]/ul/li[1]/span/span[3]");
    By clicaRelatorios = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Relatórios')]");
    By clicaMapaProducao = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Mapa de Produção')]");
    By confirmaAcessoTelaMapaProducao = By.xpath("//div[text() = 'Mapa de Produção']");
    By agrupamentoUnidade = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");

    By selecionaAgrupamento = By.xpath("//span[text() = '0000000001']");
    By chekBoxTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-TFILIAL']//span[@zh-icon='checked no-border']");

    By marcarTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-TFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");

    By checkBoxTodosGrupoServico = By.xpath("//label[@for = 'zh-checkbox-TGRUPSERV']//span[@zh-icon='checked no-border']");
    By checkBoxTodosServico = By.xpath("//label[@for = 'zh-checkbox-TSERVICO']//span[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@id= 'NMFILIAL']");

    By selecionaUnidade = By.xpath("//div[@class = 'tr cell1']//div[@data-zh-field-name='__CHECKBOX']");
    By lupaBusca = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaCampoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By marcaCheckBox = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By btnOk = By.xpath("//div[@class = 'zh-footer-right']//span[text() = 'Ok']");
    By campoGrupoServico = By.xpath("//div[@id = 'NMGRUPSERV']");

    By selecionaGruposServico = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");

    By ckeckTodosAgrupamentos = By.xpath("//label[@for = 'zh-checkbox-TGRUPSERV']//div[@class = 'zh-box mousetrap zh-ripple-effect']");

    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By selecionaServicosFiltro = By.xpath("//div[@class = 'zh-theader zh-ripple-effect']");
    By dtInicial = By.xpath("//input[@id = 'DTINTERVAL_START']");
    By dtFinal = By.xpath("//input[@id = 'DTINTERVAL_END']");
    By checkBoxQuebraPagina = By.xpath("//label[@for = 'zh-checkbox-IDQUEBRAPG']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnRelatorio = By.xpath("//li[@data-zh-id='19519847663430535914933']//span[text() = 'Relatório' ]");
    By radioPDF = By.xpath("//label[@for = 'radio-QR2TYPE-PDF']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By tituloRelatorio = By.xpath("//title[text() = 'Mapa de Produção - Grupo de Serviço']");
    By limpaAgrupamento = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border close-x']");

    By marcaTodosAgrupamentos = By.xpath("//label[@for = 'zh-checkbox-TGRUPSERV']//div[@class = 'zh-box mousetrap zh-ripple-effect']");


    public void acessaRelMapaProducao(){
        mudaUrl();
        tempo();
        waitForVisibilityOfElementLocated(usernameLoginInfoTextArea);
        click(clicaMenu);
        click(clicaPlanejamento);
        click(cClicaCardapio);
        click(clicaRelatorios);
        click(clicaMapaProducao);
        tempo();
        waitForVisibilityOfElementLocated(confirmaAcessoTelaMapaProducao);
        tempo();

    }

    public void emiteRelatorio(String DTINICIAL, String DTFINAL){
        click(agrupamentoUnidade);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        click(chekBoxTodasUnidades);
        click(campoUnidade);
        tempo();
        click(lupaBusca);
        click(lupaBusca);
        tempo();
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"0003");
        tempo();
        click(selecionaUnidade);
        click(btnOk);
        tempo();
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);
        click(btnRelatorio);
        tempo();
        click(radioPDF);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        fecharAbaRelatorio();
        click(marcarTodasUnidades);
        click(btnRelatorio);
        tempo();
        click(radioPDF);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        click(checkBoxTodosGrupoServico);
        click(campoGrupoServico);
        tempo();
        click(selecionaGruposServico);
        click(btnOk);
        click(btnRelatorio);
        tempo();
        click(radioPDF);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();
        tempo();
        tempo();
        click(checkBoxTodosServico);
        click(campoServico);
        tempo();
        click(selecionaServicosFiltro);
        click(btnOk);
        click(btnRelatorio);
        tempo();
        click(radioPDF);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();

    }

    public void quebraPagina(){
        click(limpaAgrupamento);
        tempo();
        click(marcaTodosAgrupamentos);
        tempo();
        click(checkBoxQuebraPagina);
        click(btnRelatorio);
        tempo();
        click(radioPDF);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
        tempo();
        tempo();
        fecharAbaRelatorio();

    }

}


