package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.List;

public class NutrientesProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaNutrientesProd = By.xpath("//span[text() = 'Parametrização » Planejamento » Nutrientes']");

    By produtoCloretoSodio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CLORETO DE SODIO']");
    By produtoCloretoBarioDiidratado = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CLORETO DE BARIO DIIDRATADO']");
    By produtoGrafite = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'GRAFITE']");
    By produtoFosfatoDeCalcio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'FOSFATO DE CALCIO']");
    By campoQuantLinha1 = By.xpath("//div[@id=\"grid-16760472312755473546899\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTNUTRPROD\" and @zh-events=\"column\"]");
    By campoFonteLinha1 = By.xpath("//div[@id=\"grid-16760472312755473546899\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSFONTNUTR\" and @zh-events=\"column\"]");

    By botaoAdicionar = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"1676047231159162615350\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"1676047231326765255530\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoConfirmar = By.xpath("//section[@class='popup-container']//span[text() = 'Confirmar']");
    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]//li[@data-zh-id=\"16760472313913403913408\"]");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");

    By checkBoxNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDNUTRIENTE\"]/span");
    By nomeNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By unidadeNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTNUTRPROD\"]/span");
    By fonteNutrienteLinha1 = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSFONTNUTR\"]/span");

    By campoProdutoInicial = By.id("NMPRODINI");
    By produtoInicial = By.xpath("//div[@data-zh-id=\"1676047231761490681385\"]//span[text() = '1 | MATERIA PRIMA']");
    By botaoPesquisarProdutoFinal = By.xpath("//div[@id=\"NMPRODFIN\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurarProdutoFinal = By.xpath("//li[@class='float-action expandable fix-position-bottom opened']//input[@placeholder=\"Procurar\"]");
    By produtoFinal = By.xpath("//div[@data-zh-field-name=\"CDARVPROD\"]//span[text() = '7.02.1.1.10.002.00']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioNutrientes = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto']");
    By relatorioOrdemCrescente = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto (Ordem Crescente)']");
    By relatorioOrdemDescrescente = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto (Ordem Decrescente)']");

    By todosNutrientes = By.xpath("//label[@for=\"zh-checkbox-CHECKBOXNUTRIENTES\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoNutrientes = By.id("NMNUTRIENTE");
    By nutrienteVitaminaC = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA C']");
    By nutrienteVitaminaK = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA K']");

    //nutrientes encontrados no container dos nutrientes, após os mesmos serem seleionados para geração do relatório
    By primeiroNutrienteContainer = By.xpath("//div[@id=\"NMNUTRIENTE\"]//div[@class=\"zh-options-container\"]/span[1]");
    By segundoNutrienteContainer = By.xpath("//div[@id=\"NMNUTRIENTE\"]//div[@class=\"zh-options-container\"]/span[2]");

    By ordenacaoCodigo = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-ORDENACAO\"]//label[@for=\"radio-ORDENACAO-0\"]/div");
    By ordenacaoAlfabetica = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-ORDENACAO\"]//label[@for=\"radio-ORDENACAO-1\"]/div");
    By radioOrdenacaoCodigo = By.id("radio-ORDENACAO-0");
    By radioOrdenacaoAlfabetica = By.id("radio-ORDENACAO-1");

    By campoNivel = By.xpath("//div[@data-zh-id=\"1676047231978155531400\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By listaNiveis = By.xpath("//div[@data-zh-id=\"1676047231978155531400\"]//ul[@class=\"list zh-new-select-list\"]/li");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemCantoSuperiorDireito = By.xpath("//ul[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemNaoHaRegistro = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]//p");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"1676047231761490681385\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"16760472313192712788389\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNutrientes = By.xpath("//div[@data-zh-id=\"16760472313241741951393\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes por Produto");
        click(opcaoTelaNutrientesProd);
    }

    public void adicionarNutriente() {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-16760472313207956382337 > div.grid-vertical-scroll-control\").scrollBy(0, 300)");
        click(produtoGrafite);
        click(botaoAdicionar);
        tempo();
        alterarValor(campoQuantLinha1, "32");
        alterarValor(campoFonteLinha1, "Auto");
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso, após alterar a quantidade e fonte de um nutriente");

        //valores encontrados
        String encCodigo = getText(codigoNutrienteLinha1);
        String encNome = getText(nomeNutrienteLinha1);
        String encUnidade = getText(unidadeNutrienteLinha1);
        String encQuantidade = getText(quantNutrienteLinha1);
        String encFonte = getText(fonteNutrienteLinha1);

        String expCodigo = "001";
        String expNome = "VITAMINA A";
        String expUnidade = "%";
        String expQuantidade = "32,00000";
        String expFonte = "Auto";

        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do nutriente, em que foi feita alteração na quantidade e fonte");
        Assert.assertEquals(encNome, expNome, "Verificar nome do nutriente, em que foi feita alteração na quantidade e fonte");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar unidade do nutriente, em que foi feita alteração na quantidade e fonte");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar quantidade do nutriente, em que foi feita alteração na quantidade e fonte");
        Assert.assertEquals(encFonte, expFonte, "Verificar fonte do nutriente, em que foi feita alteração na quantidade e fonte");

    }

    public void editarNutriente() {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-16760472313207956382337 > div.grid-vertical-scroll-control\").scrollBy(0, 300)");
        click(produtoFosfatoDeCalcio);
        alterarValor(quantNutrienteLinha1, "22,3");
        alterarValor(fonteNutrienteLinha1, "Automação");
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem exibida no canto superior direito, após alterar a quantidade e fonte do nutriente");

        String quantidade = getText(quantNutrienteLinha1);
        String fonte = getText(fonteNutrienteLinha1);
        Assert.assertEquals(quantidade, "22,30000", "Verificar quantidade do nutriente após a alteração");
        Assert.assertEquals(fonte, "Automação", "Verificar fonte do nutriente após a alteração");

        alterarValor(quantNutrienteLinha1, "25");
        alterarValor(fonteNutrienteLinha1, "Pesquisa");
        click(botaoSalvarAlteracoes);
        tempo();
        quantidade = getText(quantNutrienteLinha1);
        fonte = getText(fonteNutrienteLinha1);
        Assert.assertEquals(quantidade, "25,00000", "Verificar quantidade do nutriente após a alteração, retornando para o valor que estava no início do teste");
        Assert.assertEquals(fonte, "Pesquisa", "Verificar fonte do nutriente após a alteração, retornando para o valor que estava no início do teste");

    }

    public void excluirNutriente() {
        click(checkBoxNutrienteLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após cliente para excluir o nutriente do produto");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Excluído com sucesso.", "Verificar mensagem excluído com sucesso exibida no canto da tela após excluir o nutriente do produto");

        mensagem = getText(mensagemNaoHaRegistro);
        Assert.assertEquals(mensagem, "Não há registros", "Verificar mensagem exibida no grid da lista de nutrientes, informando que não há registros");
    }

    public void selecionarNutrientes() {
        click(todosNutrientes);
        click(campoNutrientes);
        click(nutrienteVitaminaC);
        click(nutrienteVitaminaK);
        click(botaoOk);
    }

    public void relatorio(String nomeRelatorio, boolean todosNutrientes) {
        click(botaoRelatorio);

        if (nomeRelatorio == "Nutrientes por Produto") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioNutrientes);
        } else if (nomeRelatorio == "Nutrientes por Produto (Ordem Crescente)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOrdemCrescente);
        } else if (nomeRelatorio == "Nutrientes por Produto (Ordem Decrescente)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOrdemDescrescente);
        }

        if (todosNutrientes) {
            selecionarNutrientes();
        }

        clicarCampoSelecionarValor(campoProdutoInicial, produtoInicial);
        click(botaoPesquisarProdutoFinal);
        sendKeys(campoProcurarProdutoFinal, "LAMINA LARGA CIS LA-L10 207.5800 (10UN)");
        click(produtoFinal);

        click(botaoConfirmar);
        click(tipoPdf);
        click(botaoConfirmar);
    }

    public void verificarCamposObrigatorios() {
        click(botaoRelatorio);
        click(todosNutrientes);
        tempo();
        click(botaoConfirmar);

        //mensagem de campo obrigatório nos campos
        String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
        String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
        String nutrientes = getText(mensagemObrigatorioNutrientes);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto inicial");
        Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto final");
        Assert.assertEquals(nutrientes, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo nutrientes");
    }

    public void verificarCampoNutriente() {
        click(botaoRelatorio);
        click(todosNutrientes);
        click(campoNutrientes);
        click(nutrienteVitaminaC);
        click(nutrienteVitaminaK);
        click(botaoOk);

        //nutrientes encontrados no container após a seleção
        String encPrimeiroNutriente = getText(primeiroNutrienteContainer);
        String encSegundoNutriente = getText(segundoNutrienteContainer);

        //nutrientes esperados no container
        String expPrimeiro = "×VITAMINA C";
        String expSegundo = "×VITAMINA K";
        Assert.assertEquals(encPrimeiroNutriente, expPrimeiro, "Verificação do primeiro nutriente encontrado no container dos nutrientes, após a seleção para geração do relatório");
        Assert.assertEquals(encSegundoNutriente, expSegundo, "Verificação do segundo nutriente encontrado no container dos nutrientes, após a seleção para geração do relatório");
    }

    public void verificarOrdenacao() {
        boolean codigo = returnIfElementIsSelected(radioOrdenacaoCodigo);
        Assert.assertEquals(codigo, true, "Verificar se por padrão a ordenação por código já vem selecionado");
        boolean nivelDesabilitado = Boolean.parseBoolean(driver.findElement(campoNivel).getAttribute("readonly"));
        Assert.assertEquals(nivelDesabilitado, true, "Verificar se com o código selecionado, o campo nível está desabilitado");

        click(ordenacaoAlfabetica);
        boolean alfabetica = returnIfElementIsSelected(radioOrdenacaoAlfabetica);
        Assert.assertEquals(alfabetica, true, "Verificar se após clicar na ordenação alfabética, a mesma passa a estar selecionada");
        nivelDesabilitado = Boolean.parseBoolean(driver.findElement(campoNivel).getAttribute("readonly"));
        Assert.assertEquals(nivelDesabilitado, false, "Verificar se com alfabética selecionada, o campo nível passa a estar habilitado");
    }

    public void verificarOpcoesNivel() {
        click(ordenacaoAlfabetica);
        click(campoNivel);

        long timeout = 0;
        List<WebElement> resultNiveis = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                listaNiveis
                        )
                );

        Assert.assertEquals(resultNiveis.size(), 6, "Verificar se a quantidade de níveis entrados está correta");

        for (int nivel = 0; nivel < resultNiveis.size(); nivel ++) {
            Assert.assertEquals(resultNiveis.get(nivel).getText(), String.valueOf(nivel), "Verificar se o nível do índice " + nivel + " da lista de níveis encontrados está correto");
        }
    }

    public void tentarAdicionarNutrienteComQuantZero() {
        click(produtoCloretoBarioDiidratado);
        click(botaoAdicionar);
        alterarValor(campoFonteLinha1, "Pesquisas");
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade deve ser maior que 0.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um nutriente com a quantidade 0");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void tentarAlterarQuantidadeZero() {
        click(produtoCloretoSodio);
        alterarValor(quantNutrienteLinha1, "0");
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade deve ser maior que 0.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar a quantidade para zera e tentar salvar as alterações");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
    }

    private void alterarValor(By campo, String valor) {
        tempo();
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(campo)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

}
