package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.AcompanhamentoPUFlows;
import com.javaseleniumtemplate.pages.AcompanhamentoPUPage;
import org.testng.annotations.Test;

public class AcompanhamentoPUTests extends TestBase {

    AcompanhamentoPUPage acompanhamentoPUPage;
    AcompanhamentoPUFlows acompanhamentoPUFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Acompanhamento de P.U.'
    //clicar no campo relatório e selecionar o relatório 'Acompanhamento de P.U.'
    //clicar no campo unidade e selecionar a unidade Deposito BC 129
    //clicar no campo mês e selecionar 11/2023
    //selecionar o 'Custo Médio Bruto Atual' no campo 'tipo custo planejado'
    //selecionar o 'Custo Médio Bruto Atual', no campo 'tipo custo realizado'
    //verificar os tipos de custo apresentados nos campo planejado e realizado, após selecionar os tipos de custo desejados
    //clicar no botão relatório, tipo pdf, clicar em confirmar, fechar a guia do relatório
    //clicar no check-box 'todos' serviços, clicar no campo serviço, selecionar 3 serviços, clicar em ok
    //clicar no botão relatório, tipo pdf, clicar em confirmar, fechar a guia do relatório
    @Test
    public void gerarRelatorio() {
        acompanhamentoPUPage = new AcompanhamentoPUPage();
        acompanhamentoPUFlows = new AcompanhamentoPUFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoPUFlows.navegateAcompanhamentoPU();
        acompanhamentoPUPage.selecionarRelatorio();
        acompanhamentoPUPage.selecionarUnidade();
        acompanhamentoPUPage.selecionarMesNovembro();
        acompanhamentoPUPage.selecionarCustos();
        acompanhamentoPUPage.geraRelatorio();
        acompanhamentoPUPage.selecionarServicos();
        acompanhamentoPUPage.geraRelatorio();
    }


    //acessar a tela 'Acompanhamento de P.U.'
    //verificar se o ceck-box 'todos' serviços está selecionado e o campo serviço está desabilitado
    //clicar no check-box 'todos' serviços, verificar se o mesmo não está mais selecionado e se o campo serviço passa a estar selecionado
    @Test
    public void campoServico() {
        acompanhamentoPUPage = new AcompanhamentoPUPage();
        acompanhamentoPUFlows = new AcompanhamentoPUFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoPUFlows.navegateAcompanhamentoPU();
        acompanhamentoPUPage.interacaoCheckBoxServico();
    }


    //acessar a tela 'Acompanhamento de P.U.'
    //clicar no botão do campo relatório, clicar no botão do campo unidade, clicar no check-box 'todos' serviços
    //clicar no botão do campo mês, clicar no botão do campo tipo de custo planejado, clicar no botão do campo tipo de custo realizado
    //verificar a mensagem de campo obrigatório nos campos: relatório, unidade, serviço, mês, tipo de custo planejado e tipo de custo realizado
    @Test
    public void camposObrigatorios() {
        acompanhamentoPUPage = new AcompanhamentoPUPage();
        acompanhamentoPUFlows = new AcompanhamentoPUFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoPUFlows.navegateAcompanhamentoPU();
        acompanhamentoPUPage.campoObrigatorios();
    }

}
