package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.CadastroServicoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class CadastroServicoTests extends TestBase {
    CadastroServicoFlows cadastroServicoFlows;
    LoginFlows loginFlows;

    public void navegaServico (String CDUNIDADE) {
        cadastroServicoFlows = new CadastroServicoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cadastroServicoFlows.navegarPaginaServico(CDUNIDADE);
    }

    public void cadastrarServico(String tipoServico){
        String nomeReduzido = "ALMOÇO";
        String nomeFantasia = "ALMOÇO";
        String horaPreparo = "05:00";
        cadastroServicoFlows.cadastraServico(nomeReduzido, nomeFantasia,tipoServico ,horaPreparo);

    }

    @Test
    public void adicionarServicoPlanejamento(){
        navegaServico("0003");
        cadastrarServico("Planejamento");
    }

    @Test
    public void adicionarServicoHospitalar(){
        navegaServico("0003");
        cadastrarServico("Hospitalar");
    }

    @Test
    public void adicionarServicoFaturamento(){
        navegaServico("0003");
        cadastrarServico("Faturamento");
    }

    @Test
    public void marcarParametrosServico(){
        navegaServico("9999");
        cadastroServicoFlows.marcaParametros("Planejamento");

    }

    @Test
    public void configurarCardapio(){
        String MSESPERADA_1 = "ARROZ";
        String MSESPERADA_2 = "GUARNIÇÃO";
        String MSESPERADA_3 = "SALADA";
        navegaServico("0004");
        cadastroServicoFlows.configurarCardapio();
        Assert.assertEquals(cadastroServicoFlows.retornaConfiguracaoPratoArroz(),MSESPERADA_1,"Configuração tipo de prato arroz");
        Assert.assertEquals(cadastroServicoFlows.retornaConfiguracaoPratoGuarnicao(),MSESPERADA_2,"Configuração tipo de prato guarnição");
        Assert.assertEquals(cadastroServicoFlows.retornaConfiguracaoPratoSalada(),MSESPERADA_3,"Configuração tipo de prato salada");

    }

    @Test
    public void exportarConfiguracaoCardapio(){
        String CDUNIDADEDEST = "9999";
        String CDSERVFILIDEST = "00002";
        navegaServico("0004");
        cadastroServicoFlows.exportarConfiguracaoCardapio(CDUNIDADEDEST,CDSERVFILIDEST);
    }

    @Test
    public void editarConfiguracaoCardapio(){
        navegaServico("0004");
        cadastroServicoFlows.editarConfigPadrao();
    }

    @Test
    public void excluirConfiguracaoCardapio(){
        navegaServico("0004");
        cadastroServicoFlows.excluirConfiguracaoCard();
    }

    @Test
    public void inserirCustoPadrao(){
        String valorCusto = "4,00";
        navegaServico("0004");
        cadastroServicoFlows.cadastrCustoPadrao(valorCusto);

    }

    @Test
    public void manutencaoCustoPadrao(){
        navegaServico("0002");
        cadastroServicoFlows.manutencaoCustoPadrao();
    }

    @Test
    public void adicionarTurnoServico(){
        String NMTURNO1 = "Manhã";
        String QTCOESTCSSEG = "100";
        String QTCOESTCSTER = "100";
        String QTCOESTCSQUA = "100";
        String QTCOESTCSQUI = "100";
        String QTCOESTCSSEX = "100";
        String NMTURNO2 = "Tarde";
        String QTCOESTCSSEG2 = "100";
        String QTCOESTCSTER2 = "100";
        String QTCOESTCSQUA2 = "100";
        String QTCOESTCSQUI2 = "100";
        String QTCOESTCSSEX2 = "100";

        navegaServico("0002");
        cadastroServicoFlows.cadastrarTurno(NMTURNO1,QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX,
                NMTURNO2,QTCOESTCSSEG2,QTCOESTCSTER2,QTCOESTCSQUA2,QTCOESTCSQUI2,QTCOESTCSSEX2);

        Assert.assertEquals(cadastroServicoFlows.validaCadastroTunoManha(),NMTURNO1,"Turno manha: ");
        Assert.assertEquals(cadastroServicoFlows.validaCadastroTunoTarde(),NMTURNO2,"Turno tarde: ");

    }

    @Test
    public void editarTunoServico(){
        String MSESPERADATURNO1 = "ALMOÇO";
        String MSESPERADATURNO2 = "JANTAR";
        String QTCOESTCSSEG =  "50";
        String QTCOESTCSTER =  "50";
        String QTCOESTCSQUA =  "50";
        String QTCOESTCSQUI =  "50";
        String QTCOESTCSSEX = " 50";
        String QTCOESTCSSEG2 = "50";
        String QTCOESTCSTER2 = "50";
        String QTCOESTCSQUA2 = "50";
        String QTCOESTCSQUI2 = "50";
        String QTCOESTCSSEX2 = "50";
        navegaServico("0002");
        cadastroServicoFlows.alterarComensaisTurno(QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX,
                QTCOESTCSSEG2,QTCOESTCSTER2,QTCOESTCSQUA2,QTCOESTCSQUI2,QTCOESTCSSEX2);

        Assert.assertEquals(cadastroServicoFlows.validaNomeAlteradoTurno1(),MSESPERADATURNO1,"Edição turno manha: ");
        Assert.assertEquals(cadastroServicoFlows.validaNomeAlteradoTurno2(),MSESPERADATURNO2,"Edição turno tarde: ");
    }

    @Test
    public void excluirTurnoServico(){
        String MSGESPERADA = "Não há registros";
        navegaServico("0002");
        cadastroServicoFlows.excluindoTurno();
        Assert.assertEquals(cadastroServicoFlows.validarExclusaoTurno(),MSGESPERADA,"Validando Se o Tuno foi apagago: ");
    }

    @Test
    public void informarComensaisServico(){
        String QTCOMESTISEG = "50";
        String QTCOMESTITER = "50";
        String QTCOMESTIQUA = "50";
        String QTCOMESTIQUI = "50";
        String QTCOMESTISEX = "50";
        navegaServico("0002");
        cadastroServicoFlows.insereComensaisServico(QTCOMESTISEG, QTCOMESTITER, QTCOMESTIQUA, QTCOMESTIQUI, QTCOMESTISEX);

    }

    @Test
    public void alterarComensalServico(){
        String QTCOESTCSSEG = "100";
        String QTCOESTCSTER = "100";
        String QTCOESTCSQUA = "100";
        String QTCOESTCSQUI = "100";
        String QTCOESTCSSEX = "100";
        navegaServico("9999");
        cadastroServicoFlows.alteraComensaisPontoEntrega(QTCOESTCSSEG,QTCOESTCSTER,QTCOESTCSQUA,QTCOESTCSQUI,QTCOESTCSSEX);
    }

    @Test
    public void exportarComensais(){
        String DTINICIAL = "01/12/2023";
        String DTFINAL   = "31/12/2023";
        navegaServico("0002");
        cadastroServicoFlows.exportaComensais(DTINICIAL, DTFINAL);

    }

    @Test
    public void adicionarPontoEntrega(){
        String QTDCOESTCSSEG = "100";
        String QTDCOMESTITER = "100";
        String QTDCOMESTIQUA = "100";
        String QTDCOESTCSQUI = "100";
        String QTDCOMESTISEX = "100";
        navegaServico("0002");
        String NMPONTOENTREGA = "DROGARIA GOMES CARDIM LTDA";
        cadastroServicoFlows.informaPontoEntrega(NMPONTOENTREGA);
        Assert.assertEquals(cadastroServicoFlows.validaCadastroPontoEntrega(),NMPONTOENTREGA,"Validando relacionar ponto de entrega ao serviço: ");
        cadastroServicoFlows.insereComensalPontoEntrega(QTDCOESTCSSEG,QTDCOMESTITER,QTDCOMESTIQUA,QTDCOESTCSQUI,QTDCOMESTISEX);
    }

    @Test
    public void excluirPontoEntrega(){
        String MSGESPERADA = "Não há registros";
        navegaServico("0002");
        cadastroServicoFlows.apagaPontoEntrega();
        Assert.assertEquals(cadastroServicoFlows.validaExclusaoPontoEntrega(),MSGESPERADA,"Validando Se o Tuno foi apagago: ");
    }

    @Test
    public void adicionaProdutoFaturamento(){
        String CDSERVICO = "00052";
        String NMPRODUTO = "CREOSOTO";
        String VALPERCENT = "100";
        navegaServico("0003");
        cadastroServicoFlows.abaFaturamento(CDSERVICO, NMPRODUTO, VALPERCENT);
    }

    @Test
    public void editarProdutoFaturamento(){
        String CDPRODFATU = "101110100201";
        String NMPRODUTO = "OLEO DE CASTANHA DO BRASIL EMBALAGEM 1 LITRO";
        navegaServico("0003");
        cadastroServicoFlows.alteraProdutoFaturamento(CDPRODFATU);
        Assert.assertEquals(NMPRODUTO,cadastroServicoFlows.validaProdutoAlterado(),"Valida se o produto foi alterado corretamente: ");
    }

    @Test
    public void excluirProdutoServicoFaturamento(){
        String mensagemEsperada = "Não há registros";
        navegaServico("0003");
        cadastroServicoFlows.apagaServicoProdutoFaturamento();
        Assert.assertEquals(cadastroServicoFlows.validarExclusaoProdServFat(),mensagemEsperada,"Exclusão do produto/serviço aba faturamento: ");
    }

    @Test
    public void adicionaInformacaoAplicativos(){
        navegaServico("0002");
        cadastroServicoFlows.adicionaInformacaoAplicativo();

    }

    @Test
    public void editarInformacaoAplicativos(){
        String tipoAcao = "Editar";
        navegaServico("0002");
        cadastroServicoFlows.editarExcluirInfoAplicativos(tipoAcao);
    }

    @Test
    public void excluirInformacaoAplicativos(){
        String tipoAcao = "Excluir";
        navegaServico("0002");
        cadastroServicoFlows.editarExcluirInfoAplicativos(tipoAcao);
    }

    @Test
    public void adicionarEmbalagemPontoEntrega(){
        String TIPOEXPORTACAO = "Ponto de Entrega";
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        String NMEMBALAGEM = "DISTRIBUICAO AUTOMATICA";
        navegaServico("0002");
        cadastroServicoFlows.abaEmbalagens(TIPOEXPORTACAO,NMPONTOENTREGA, NMEMBALAGEM);

    }

    @Test
    public void adicionarEmbalagemServico(){
        String TIPOEXPORTACAO = "Serviço";
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        String NMEMBALAGEM = "DISTRIBUICAO AUTOMATICA";
        navegaServico("0002");
        cadastroServicoFlows.abaEmbalagens(TIPOEXPORTACAO,NMPONTOENTREGA, NMEMBALAGEM);

    }

    @Test
    public void exportarEmbalagemRelacionadaPontoEntrega() {
        String TIPOEXPORTACAO = "Ponto de entrega";
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        String NMPONTOENTREGADEST = "RESTAURANTE NORMAS";
        String CDFILIAL = "0003";
        navegaServico("0002");
        cadastroServicoFlows.exportaEmbalagemPontoEntrega(TIPOEXPORTACAO,NMPONTOENTREGA, CDFILIAL,NMPONTOENTREGADEST);
    }

    @Test
    public void importarEmbalagemRelacionadaPontoEntrega(){
        String CDUNIDADE = "9999";
        String TIPOIMPORTACAO = "PontoEntrega";
        navegaServico("0004");
        cadastroServicoFlows.importaEmbalagem(CDUNIDADE, TIPOIMPORTACAO);
    }

    @Test
    public void excluirEmbalagemPontoEntrega(){
        String TIPOEXCLUSAO = "PontoEntrega";
        String NMPONTOENTREGA = "DROGARIA FIBERSAL";
        navegaServico("0002");
        cadastroServicoFlows.excluirEmbalagemPontoEntrega(TIPOEXCLUSAO,NMPONTOENTREGA);
    }

}
