package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmissaoCardapioSemanaFlows;
import com.javaseleniumtemplate.pages.EmissaoCardapioSemanaPage;
import org.testng.annotations.Test;

public class EmissaoCardapioSemanaTests extends TestBase {

    EmissaoCardapioSemanaPage emissaoCardapioSemanaPage;
    EmissaoCardapioSemanaFlows emissaoCardapioSemanaFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAlergenico() {
        emitiRelatorio("Emissão de Cardápio da Semana - Alergênico", "Não imprimir");
    }

    @Test
    public void relatorioCardapioSemana() {
        emitiRelatorio("Emissão do Cardápio da Semana", "Número");
    }

    @Test
    public void relatorioCusto() {
        emitiRelatorio("Emissão de Cardápio da Semana (Custo)", "Percentual");
    }



    //acessar a tela 'Emissão do Cardápio da Semana'
    //selecionar o relatório que foi passado como parâmetro
    //selecionar a unidade Deposito Jabaquara
    //selecionar a comensal que foi passada como parâmetro
    //clicar no botão relatório, clicar em pdf, clicar em confirmar, verificar se a url do relatório está correta e fechar a guia do relatório
    //atualizar a página e selecionar novamente o relatório que foi passado como parâmetro
    //selecionar 2 serviços, clicar no agrupamento por 'serviço'
    //caso o relatório seja 'Emissão de Cardápio da Semana - Alergênico' ou 'Emissão do Cardápio da Semana', será aberto o grid dos dias da semana
    //serão selecionados os dias domingo e segunda-feita, clicar em ok
    //caso o relatório seja 'Emissão de Cardápio da Semana (Custo)', clicar no campo tipo de custo, selecionar o tipo de 'Custo Médio Bruto Atual'
    //verificar o valor apresentado no campo tipo de custo, clicar em calcular custo planejado com base na data 'do cardápio'
    //qualquer relatório que seja, será selecionada a comensal que foi passada como parâmetro
    //clicar no botão relatório, clicar em pdf, clicar em confirmar, verificar se a url do relatório está correta e fechar a guia do relatório
    public void emitiRelatorio(String nomeDoRelatorio, String nomeComensal) {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.selecionaRelatorio(nomeDoRelatorio);
        emissaoCardapioSemanaPage.selecionarUnidade();
        emissaoCardapioSemanaPage.selecionarComensal(nomeComensal);
        emissaoCardapioSemanaPage.geraRelatorio();
        emissaoCardapioSemanaPage.refresh();
        emissaoCardapioSemanaPage.selecionaRelatorio(nomeDoRelatorio);
        emissaoCardapioSemanaPage.selecionarUnidade();
        emissaoCardapioSemanaPage.selecionarServico();
        emissaoCardapioSemanaPage.selecionarAgruparPorServico();

        if (nomeDoRelatorio == "Emissão de Cardápio da Semana - Alergênico" || nomeDoRelatorio == "Emissão do Cardápio da Semana") {
            emissaoCardapioSemanaPage.selecionarDias();
        }
        else if (nomeDoRelatorio == "Emissão de Cardápio da Semana (Custo)") {
            emissaoCardapioSemanaPage.selecionarTipoDeCusto();
            emissaoCardapioSemanaPage.selecionarBaseCardapio();
        }
        emissaoCardapioSemanaPage.selecionarComensal(nomeComensal);
        emissaoCardapioSemanaPage.geraRelatorio();
    }









    //acessar a tela 'Emissão do Cardápio da Semana'
    //clicar no campo relatório, selecionar o relatório 'Emissão do Cardápio da Semana', verificar se o campo tipo de custo e os radios buttons 'de referência' e 'de cardápio', estão desabilitados
    //clicar no campo relatório, selecionar o relatório '"Emissão de Cardápio da Semana (Custo)"', verificar se o campo tipo de custo e os radios buttons 'de referência' e 'de cardápio', estão habilitados
    //clicar no campo relatório, selecionar o relatório 'Emissão de Cardápio da Semana - Alergênico', verificar se o campo tipo de custo e os radios buttons 'de referência' e 'de cardápio', estão desabilitados
    @Test
    public void tiposCustoHabOuDesabNosRelatorios() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.camposTipoCustoHabilitosPelosRelatorios();
    }


    //acessar a tela 'Emissão do Cardápio da Semana'
    //selecionar o relatório 'Emissão do Cardápio da Semana'
    //clicar no radio-button de comensais 'não imprimir' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'número' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'percentual' e verificar se o mesmo está selecionado
    //clicar no radio-button de agrupar por 'semana' e verificar se o mesmo fica selecionado
    //clicar no radio-button de agrupar por 'serviço' e verificar se o mesmo fica selecionado
    //verificar se o check-box de 'imprimir mensagem' não está selecionado, clicar no check-box de 'imprimir mensagem' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'imprimir nome fantasia' não está selecionado, clicar no check-box de 'imprimir nome fantasia' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'quebra de página' está selecionado, clicar no check-box de 'quebra de página' e verificar se o mesmo passa a não estar mais selecionado
    //verificar se o check-box de 'quebra por mês' está selecionado, clicar no check-box de 'quebra por mês' e verificar se o mesmo passa a não estar mais selecionado
    @Test
    public void interacaoCheckBoxRelatEmissaoSemana() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        String relatorio = "Emissão do Cardápio da Semana";

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.selecionaRelatorio(relatorio);
        emissaoCardapioSemanaPage.verificarBotoesComensais();
        emissaoCardapioSemanaPage.verificarBotoesAgruparPor();
        emissaoCardapioSemanaPage.verificarOpcoesCheckBox();
    }


    //acessar a tela 'Emissão do Cardápio da Semana'
    //selecionar o relatório 'Emissão de Cardápio da Semana (Custo)'
    //clicar no radio-button de comensais 'não imprimir' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'número' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'percentual' e verificar se o mesmo está selecionado
    //clicar no radio-button de agrupar por 'semana' e verificar se o mesmo fica selecionado
    //clicar no radio-button de agrupar por 'serviço' e verificar se o mesmo fica selecionado
    //verificar se o check-box de 'imprimir mensagem' não está selecionado, clicar no check-box de 'imprimir mensagem' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'imprimir nome fantasia' não está selecionado, clicar no check-box de 'imprimir nome fantasia' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'quebra de página' está selecionado, clicar no check-box de 'quebra de página' e verificar se o mesmo passa a não estar mais selecionado
    //verificar se o check-box de 'quebra por mês' está selecionado, clicar no check-box de 'quebra por mês' e verificar se o mesmo passa a não estar mais selecionado
    //clicar no radio-button de calcular custo planejado com base na data 'de referência' e verificar se o mesmo fica selecionado
    //clicar no radio-button de calcular custo planejado com base na data 'de cardápio' e verificar se o mesmo fica selecionado
    @Test
    public void interacaoCheckBoxRelatEmissaoSemanaCusto() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        String relatorio = "Emissão de Cardápio da Semana (Custo)";

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.selecionaRelatorio(relatorio);
        emissaoCardapioSemanaPage.verificarBotoesComensais();
        emissaoCardapioSemanaPage.verificarBotoesAgruparPor();
        emissaoCardapioSemanaPage.verificarOpcoesCheckBox();
        emissaoCardapioSemanaPage.verificarBotoesCalcularCustoPlanejado();
    }


    //acessar a tela 'Emissão do Cardápio da Semana'
    //selecionar o relatório 'Emissão de Cardápio da Semana - Alergênico'
    //clicar no radio-button de comensais 'não imprimir' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'número' e verificar se o mesmo está selecionado
    //clicar no radio-button de comensais 'percentual' e verificar se o mesmo está selecionado
    //clicar no radio-button de agrupar por 'semana' e verificar se o mesmo fica selecionado
    //clicar no radio-button de agrupar por 'serviço' e verificar se o mesmo fica selecionado
    //verificar se o check-box de 'imprimir mensagem' não está selecionado, clicar no check-box de 'imprimir mensagem' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'imprimir nome fantasia' não está selecionado, clicar no check-box de 'imprimir nome fantasia' e verificar se o mesmo passa a estar selecionado
    //verificar se o check-box de 'quebra de página' está selecionado, clicar no check-box de 'quebra de página' e verificar se o mesmo passa a não estar mais selecionado
    //verificar se o check-box de 'quebra por mês' está selecionado, clicar no check-box de 'quebra por mês' e verificar se o mesmo passa a não estar mais selecionado
    @Test
    public void interacaoBotoesRelatEmissaoSemanaAlergenico() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        String relatorio = "Emissão de Cardápio da Semana - Alergênico";

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.selecionaRelatorio(relatorio);
        emissaoCardapioSemanaPage.verificarBotoesComensais();
        emissaoCardapioSemanaPage.verificarBotoesAgruparPor();
        emissaoCardapioSemanaPage.verificarOpcoesCheckBox();
    }


    //acessar a tela 'Emissão do Cardápio da Semana'
    //clicar no botão do campo da semana inicial, clicar no campo e preencher com a data 30/06/2023
    //clicar no número da semana final, para que o número da semana inicial seja atualizado conforme a data que foi inserida
    //verificar se o número da semana inicial e a data da semana inicial ficaram corretas, após a alteração na data da semana inicial
    //clicar no botão '+' do número da semana inicial e verificar se o valor do número da semana inicial e a data da semana inicial, foram atualizados corretamente
    //clicar duas vezes no botão '-' do número da semana inicial e verificar se o valor do número da semana inicial e a data da semana inicial, foram atualizados corretamente
    //clicar no botão do campo da semana final, clicar no campo e preencher com a data 20/09/2023
    //clicar no número da semana inicial, para que o número da semana final seja atualizado conforme a data que foi inserida
    //verificar se o número da semana final e a data da semana final ficaram corretas, após a alteração na data da semana final
    //clicar no botão '+' do número da semana final e verificar se o valor do número da semana final e a data da semana final, foram atualizados corretamente
    //clicar duas vezes no botão '-' do número da semana final e verificar se o valor do número da semana final e a data da semana final, foram atualizados corretamente
    @Test
    public void interacaoCampoDasSemanas() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.interacaoNumeroEDataSemanaInicial();
        emissaoCardapioSemanaPage.interacaoNumeroEDataSemanaFinal();
    }


    //acessar a tela 'Emissão do Cardápio da Semana'
    //selecionar o relatório 'Emissão do Cardápio da Semana' e verificar se os campos (unidade, serviço, semana inicial, semana final e imprimir dias da semana) são campos obrigatórios
    //atualizar a página, selecionar o relatório 'Emissão de Cardápio da Semana (Custo)'
    //verificar se os campos (unidade, serviço, semana inicial, semana final e tipo de custo) são campos obrigatórios
    //atualizar a página, selecionar o relatório 'Emissão de Cardápio da Semana - Alergênico'
    //verificar se os campos (unidade, serviço, semana inicial, semana final e imprimir dias da semana) são campos obrigatórios
    @Test
    public void campoObrigatoriosRelatorioEmissaoCardSemana() {
        emissaoCardapioSemanaPage = new EmissaoCardapioSemanaPage();
        emissaoCardapioSemanaFlows = new EmissaoCardapioSemanaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioSemanaFlows.navegateEmissaoCardapioSemana();
        emissaoCardapioSemanaPage.camposObrigatorios("Emissão do Cardápio da Semana");
        emissaoCardapioSemanaPage.refresh();
        emissaoCardapioSemanaPage.camposObrigatorios("Emissão de Cardápio da Semana (Custo)");
        emissaoCardapioSemanaPage.refresh();
        emissaoCardapioSemanaPage.camposObrigatorios("Emissão de Cardápio da Semana - Alergênico");
    }


}
