package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ExclusaoDeCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ExclusaoDeCardapioTests extends TestBase {
    ExclusaoDeCardapioFlows exclusaoDeCardapioFlows;
    LoginFlows loginFlows;

    public void acessarTela(){
        String nomeTela = "Exclusão de Cardápio";
        exclusaoDeCardapioFlows = new ExclusaoDeCardapioFlows();
        loginFlows = new LoginFlows();
        loginFlows.efetuarLogin();
        exclusaoDeCardapioFlows.navegarExclusaoCardapio();
        Assert.assertEquals(exclusaoDeCardapioFlows.confirmarAcessoTelaExclusao(),nomeTela,"Confirma acesso tela: ");

    }


    @Test
    public void validarCamposObrigatorios(){
        acessarTela();
        String msgEsperada = "Campo obrigatório";
        exclusaoDeCardapioFlows.validarCamposObrigatorios();
        Assert.assertEquals(exclusaoDeCardapioFlows.msgObrigatorioCampoUnidade(),msgEsperada,"Campo Unidade: ");
        Assert.assertEquals(exclusaoDeCardapioFlows.msgObrigatorioCampoServico(),msgEsperada,"Campo Serviço: ");
        Assert.assertEquals(exclusaoDeCardapioFlows.msgObrigatorioCampoData(),msgEsperada,"Campo Data: ");

    }


    @Test
    public void excluirCardapioPeriodoBloqueado(){
        String cdAgrupamento = "";
        String cdFilial = "0003";
        String cdServico = "00003";
        String msgEsperada = "Cardápios Bloqueados";
        acessarTela();
        exclusaoDeCardapioFlows.realizaFiltros(cdAgrupamento,cdFilial,cdServico);
        exclusaoDeCardapioFlows.informaDatas("01/12/2022","31/12/2022");
        exclusaoDeCardapioFlows.excluirPeriodoBloqueadoVazio();
        Assert.assertEquals(exclusaoDeCardapioFlows.retornaMensagemBloqueio(),msgEsperada,"Bloqueio de cardápio: ");


    }

    @Test
    public void excluirCardapioSemPrato(){
        String cdAgrupamento = "0000000002";
        String cdFilial = "0002";
        String cdServico = "00001";
        String msgEsperada = "Não há cardápio no período informado.";
        acessarTela();
        exclusaoDeCardapioFlows.realizaFiltros(cdAgrupamento,cdFilial,cdServico);
        exclusaoDeCardapioFlows.informaDatas("01/12/2025","31/12/2025");
        exclusaoDeCardapioFlows.excluirPeriodoBloqueadoVazio();
        Assert.assertEquals(exclusaoDeCardapioFlows.cardapioVazio(),msgEsperada,"Valizando mensagem cardápio vazio: ");

    }

    @Test
    public void excluirCardapioPeriodo(){
        String cdAgrupamento = "0000000002";
        String cdFilial = "0002";
        String cdServico = "00002";
        acessarTela();
        exclusaoDeCardapioFlows.realizaFiltros(cdAgrupamento,cdFilial,cdServico);
        exclusaoDeCardapioFlows.informaDatas("02/02/2024","02/02/2024");
        exclusaoDeCardapioFlows.excluirCardapioElaboradoPeriodo();
    }




}
