package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.GrupoServicosFlows;
import com.javaseleniumtemplate.pages.GrupoServicosPage;
import org.testng.annotations.Test;

public class GrupoServicosTests extends TestBase {

    GrupoServicosPage grupoServicosPage;
    GrupoServicosFlows grupoServicosFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Grupo de Serviços'
    //clicar no botão adicionar, preencher os campos: código e nome
    //clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //atualizar a página e no filtro da tela, procurar por 010
    //verificar se o código e nome do grupo de serviços foram salvos corretamente
    //selecionar o check-box do grupo de serviços, clicar em excluir, verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar a mensagem exibida no grid da lista de grupo de serviços, informando que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirGrupoServicos() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.adicionarGrupo();
        grupoServicosPage.excluirGrupo();
    }


    //acessar a tela 'Grupo de Serviços'
    //no filtro da tela, procurar por 005
    //alterar o nome do grupo de serviços e clicar em salvar alterações
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //atualizar a página, no filtro procurar novamente por 005
    //verificar se o nome do grupo foi salvo corretamente
    //alterar o nome do grupo, retornando para o nome que estava no início do teste, clicar em salvar alterações e verificar se o nome foi salvo corretamente
    @Test
    public void alterarNomeGrupoDeServicos() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.editarNomeGrupoServico();
    }


    //acessar a tela 'Grupo de Serviços'
    //no filtro da tela, procurar por 006
    //verificar se o grupo de serviços é o 'TRANSP.'
    //clicar no código do grupo de serviços, clicar na aba serviços
    //no campo 'ordenação de transportes', tentar inserir um valor com letras e verificar se é exibida uma mensagem informando que o valor deve ser número
    //no campo 'ordenação de transportes', tentar inserir um valor com caracteres especiais e verificar se é exibida uma mensagem informando que o valor deve ser número
    //no campo 'ordenação de transportes', tentar inserir o valor 0 e verificar se é exibida uma mensagem informando que o valor deve ser número
    //no campo 'ordenação de transportes', inserir o valor 7, clicar em salvar alterações e verificar se o valor foi salvar corretamente
    //no campo 'ordenação de transportes', deixar o campo vazio clicar em salvar alterações e verificar se o valor foi salvar corretamente
    //verificar o código e o nome do serviço em que foram feitos os teste no valor da ordenação de transporte
    @Test
    public void ordenacaoTransporteAbaServicos() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.verificarOrdenacaoTranspAbaServicos();
    }


    //acessar a tela 'Grupo de Serviços'
    //no filtro da tela, procurar por 001
    //clicar no check-box do grupo, clicar em excluir
    //verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem exibida na tela informando que a exclusão não pode ser realizada, pois o registro possuí registros filhos
    //clicar em ok, clicar no check-box e no código do grupo de serviços para garantir que o mesmo não foi excluído
    @Test
    public void tentarExcluirGrupoComRegistroFilhos() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.tentarExcluirGrupoComRegistroFilhos();
    }


    //acessar a tela 'Grupo de Serviços'
    //clicar em adicionar, preencher os campos código (com um valor já cadastrado) e nome
    //clicar em salvar, verificar a mensagem exibida na tela informando que o registro já existe
    //clicar em ok
    @Test
    public void tentarAdicionarCodigoExistente() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.tentarAddCodigoExistente();
    }


    //acessar a tela 'Grupo de Serviços'
    //clicar no botão adicionar, clicar em salvar
    //verificar se nos campos código e nome, é exibida a mensagem de campo obrigatório
    //clicar em cancelar
    @Test
    public void camposObrigatorios() {
        grupoServicosPage = new GrupoServicosPage();
        grupoServicosFlows = new GrupoServicosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoServicosFlows.navegateRelaGrupoServicos();
        grupoServicosPage.camposObrigatorios();
    }

}
