package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LiberacaoDeCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

public class LiberacaoDeCardapioTests extends TestBase {
    LoginFlows loginFlows;
    LiberacaoDeCardapioFlows liberacaoDeCardapioFlows;


    public void acessarTelaLiberacaoCardapioUnidade(String acaoFilto){
        loginFlows = new LoginFlows();
        liberacaoDeCardapioFlows = new LiberacaoDeCardapioFlows();
        loginFlows.efetuarLogin();
        liberacaoDeCardapioFlows.acessarTela();
        if (acaoFilto == "Todos"){
            liberacaoDeCardapioFlows.realizaFiltroTodos();
        }else{
            liberacaoDeCardapioFlows.realizaFiltro();
        }

    }

    //Libera cardápio considerando apenas um serviço
    @Test
    public void Test1() {
        String acao = "Liberar";
        String acaoFiltro = " ";
        acessarTelaLiberacaoCardapioUnidade(acaoFiltro);
        liberacaoDeCardapioFlows.liberarCardapioUnidade();
        liberacaoDeCardapioFlows.envioDeEmail(acao);

    }

    //Cancela cardápio considerando apenas um serviço
    @Test
    public void Test2(){
        String acao = "Cancelar";
        String acaoFiltro = " ";
        acessarTelaLiberacaoCardapioUnidade(acaoFiltro);
        liberacaoDeCardapioFlows.cancelaLiberacaoCardapio();
        liberacaoDeCardapioFlows.envioDeEmail(acao);
    }

    //Libera todos os serviços da unidade.
    @Test
    public void Teste3(){
        String acao = "Liberar";
        String acaoFiltro = "Todos";
        acessarTelaLiberacaoCardapioUnidade(acaoFiltro);
        liberacaoDeCardapioFlows.liberaTodosServicos();
        liberacaoDeCardapioFlows.envioDeEmail(acao);
    }

    //Cancela liberação de todos os serviços liberados.
    @Test
    public void Teste4(){
        String acao = "Cancelar";
        String acaoFiltro = "Todos";
        acessarTelaLiberacaoCardapioUnidade(acaoFiltro);
        liberacaoDeCardapioFlows.cancelaTodosServicos();
        liberacaoDeCardapioFlows.envioDeEmail(acao);
    }

    //Emissão de relatórios
    @Test
    public void Teste5(){
        String acaoFiltro = " ";
        acessarTelaLiberacaoCardapioUnidade(acaoFiltro);
        liberacaoDeCardapioFlows.emitirRelatorioHistorico();
    }

}
