package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesProdutoFlows;
import com.javaseleniumtemplate.pages.NutrientesProdutoPage;
import org.testng.annotations.Test;

public class NutrientesProdutoTests extends TestBase {

    NutrientesProdutoPage nutrientesProdutoPage;
    NutrientesProdutoFlows nutrientesProdutoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Nutrientes por Produto'
    //rolar um pouco a página, clicar no produto GRAFITE, clicar no botão adicionar
    //preencher a quantidade e a fonte, clicar no botão salvar alterações
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se as informações (código, nome, unidade, quantidade e fonte) do nutriente foram salvos corretamente
    //clicar no check-box do nutriente, clicar no botão excluir, verificar a mensagem exibida na tela, clicar no botão sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar mensagem de não há registros, exibida no grid de lista dos nutrientes, após a exclusão do nutriente que foi adicionado
    @Test
    public void adicionarExcluir() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.adicionarNutriente();
        nutrientesProdutoPage.excluirNutriente();
    }


    //acessar a tela 'Nutrientes por Produto'
    //rolar um pouco a página, clicar no produto FOSFATO DE CALCIO
    //alterar alterar quantidade e fonte do nutriente, clicar no botão 'Salvar alterações'
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se a quantidade e fonte foram alterados com sucesso
    //alterar novamente a quantidade e a fonte do nutriente, retornando os valores para os que estavam no início do teste
    //clicar no botão 'Salvar alterações'
    //verificar se a quantidade e fonte, foram salvos corretamente
    @Test
    public void editarNutriente() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.editarNutriente();
    }


    //acessar a tela 'Nutrientes por Produto'
    //clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto', deixar a opção todos os nutrientes selecionada
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    //atualizar a página, clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto'
    //clicar na opção todos nutrientes, clicar no campo nutrientes, selecionar alguns nutrientes, clicar no botão ok
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    @Test
    public void relatorioNutrientesPorProduto() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto", false);
        nutrientesProdutoPage.refresh();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto", true);
    }


    //acessar a tela 'Nutrientes por Produto'
    //clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto (Ordem Crescente)', deixar a opção todos os nutrientes selecionada
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    //atualizar a página, clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto (Ordem Crescente)'
    //clicar na opção todos nutrientes, clicar no campo nutrientes, selecionar alguns nutrientes, clicar no botão ok
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    @Test
    public void relatorioNutrientesProdutoOrdemCrescente() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Crescente)", false);
        nutrientesProdutoPage.refresh();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Crescente)", true);
    }


    //acessar a tela 'Nutrientes por Produto'
    //clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto (Ordem Decrescente)', deixar a opção todos os nutrientes selecionada
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    //atualizar a página, clicar no botão relatório, selecionar o relatório 'Nutrientes por Produto (Ordem Decrescente)'
    //clicar na opção todos nutrientes, clicar no campo nutrientes, selecionar alguns nutrientes, clicar no botão ok
    //clicar no campo produto inicial e selecionar o produto inicial clicar no botão do campo produto final, procurar pelo produto LAMINA LARGA CIS LA-L10 207.5800 (10UN) e selecionar o mesmo
    //clicar no botão confirmar, tipo pdf, e confirmar
    @Test
    public void relatorioNutrientesProdutoOrdemDecrescente() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Decrescente)", false);
        nutrientesProdutoPage.refresh();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Decrescente)", true);
    }


    //acessar a tela 'Nutrientes por Produto'
    //clicar no botão relatório, clicar na opção 'todos' nutrientes, clicar em confirmar
    //verificar a mensagem de campo obrigatório nos campos: produto inicial, produto final e nutrientes
    //atualizar a página, clicar no botão relatório, clicar em 'todos' os nutrientes, clicar no campo nutrientes, selecionar (vitamina C e vitamina k), clicar em ok
    //verificar se esses nutrientes são exibidos no campo nutrientes
    //verificar se o radio-button código está selecionado, e o campo nível está desabilitado
    //clicar no radio-button alfabética e verificar se o campo nível fica habilitado
    //clicar no campo nível e verificar se as opções vão de 0 a 5
    @Test
    public void verificarCamposObrigatorioNutriENiveis() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.verificarCamposObrigatorios();
        nutrientesProdutoPage.refresh();
        nutrientesProdutoPage.verificarCampoNutriente();
        nutrientesProdutoPage.verificarOrdenacao();
        nutrientesProdutoPage.verificarOpcoesNivel();
    }


    //acessar a tela 'Nutrientes por Produto'
    //clicar no produto CLORETO DE BARIO DIIDRATADO, clicar no botão adicionar, preencher o campo fonte, clicar em 'salvar alterações'
    //verificar a mensagem exibida na tela informando que a quantidade deve ser maior que 0, clicar em ok, clicar em cancelar e clicar em voltar
    //clicar no produto CLORETO DE SODIO, alterar a quantidade para 0, clicar em 'salvar alterações'
    //verificar a mensagem exibida na tela informando que a quantidade deve ser maior que 0, clicar em ok e clicar em cancelar
    @Test
    public void tentarAdicioarEditarQuantZero() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.tentarAdicionarNutrienteComQuantZero();
        nutrientesProdutoPage.tentarAlterarQuantidadeZero();
    }

}
