package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PesquisaConsumoProdutoFlows;
import com.javaseleniumtemplate.pages.PesquisaConsumoProdutoPage;
import org.testng.annotations.Test;

public class PesquisaConsumoProdutoTests extends TestBase {

    PesquisaConsumoProdutoPage pesquisaConsumoProdutoPage;
    PesquisaConsumoProdutoFlows pesquisaConsumoProdutoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Pesquisa de Consumo de Produtos'
    //clicar no campo relatório e selecionar o relatório 'Pesquisa de Consumo de Produtos'
    //clicar no campo unidade e selecionar a unidade 'DEPOSITO BC 129'
    //clicar no check-box todos os serviços, clicar no campo serviço, selecionar os serviços Retiradas e Jantas, cliclar no botão OK
    //preencher a data inicial e final, clicar no   campo produto, selecionar o produto CREOSOTO, clicar em ok
    //clicar no botão do campo prato inicial, pesquisar pelo prato ARROZ TEMPEREADO e selecionar o mesmo
    //clicar no botão do campo prato final, pesquisar pelo prato FEIJÃO TROPEIRO e selecionar o mesmo
    //selecionar a ordenação alfabética, clicar em relatório, pdf e confirmar, fechar a guia do relatório que será gerado
    //recarregar a tela 'Pesquisa de Consumo de Produtos', selecionar novamente o relatório 'Pesquisa de Consumo de Produtos' e preencher as datas inicial e final
    //deixar o check-box 'Todos' selecionado nos campos unidade e produto, clicar no botão relatório, pdf, confirmar, fechar a guia do relatório que será gerado
    //deixar apenas o tipos de consumo 'Cardápio' selecionado, gerar novamente o relatório e fechar a guia do mesmo
    //deixar apenas o tipos de consumo 'Fixo' selecionado, gerar novamente o relatório e fechar a guia do mesmo
    //deixar apenas o tipos de consumo 'Per Capita' selecionado, gerar novamente o relatório e fechar a guia do mesmo
    @Test
    public void gerarRelatorio() {
        pesquisaConsumoProdutoPage = new PesquisaConsumoProdutoPage();
        pesquisaConsumoProdutoFlows = new PesquisaConsumoProdutoFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/01/2024";
        String dataFinal = "31/01/2024";

        loginFlows.efetuarLogin();
        pesquisaConsumoProdutoFlows.navegateTelaConsumoConsumoProduto();
        pesquisaConsumoProdutoPage.selecionarRelatorio();
        pesquisaConsumoProdutoPage.selecionarUnidade();
        pesquisaConsumoProdutoPage.selecionarServicos();
        pesquisaConsumoProdutoPage.preencherDatas(dataInicial, dataFinal);
        pesquisaConsumoProdutoPage.selecionarProduto();
        pesquisaConsumoProdutoPage.selecionarPratos();
        pesquisaConsumoProdutoPage.selecionarOrdenacao("Alfabética");
        pesquisaConsumoProdutoPage.geraRelatorio();
        pesquisaConsumoProdutoPage.selecionarOrdenacao("Código");
        pesquisaConsumoProdutoPage.geraRelatorio();

        pesquisaConsumoProdutoPage.refresh();
        pesquisaConsumoProdutoPage.selecionarRelatorio();
        pesquisaConsumoProdutoPage.preencherDatas(dataInicial, dataFinal);
        pesquisaConsumoProdutoPage.deixarTodosSelecionado();
        pesquisaConsumoProdutoPage.geraRelatorio();

        pesquisaConsumoProdutoPage.tipoConsumo("Cardápio");
        pesquisaConsumoProdutoPage.geraRelatorio();
        pesquisaConsumoProdutoPage.tipoConsumo("Fixo");
        pesquisaConsumoProdutoPage.geraRelatorio();
        pesquisaConsumoProdutoPage.tipoConsumo("Per Capita");
        pesquisaConsumoProdutoPage.geraRelatorio();
    }


    //acessar a tela 'Pesquisa de Consumo de Produtos'
    //clicar no botão do campo relatório, clicar no check-box 'Todos' do campo serviço, clicar no botão do campo período, clicar no botão relatório
    //verificar a mensagem de campo obrigatórios nos campos: relatório, unidade, serviço, período e produto
    //atualizar a página, selecionar o check-box 'Todos' dos campos unidade e produto
    //clicar nos check-box de todos os tipos de consumo (cardápio, fixo e per capita) deixando todos desmarcados
    //clicar no botão relatório, verificar a mensagem exibida na tela e clicar em ok
    @Test
    public void camposObrigatorios() {
        pesquisaConsumoProdutoPage = new PesquisaConsumoProdutoPage();
        pesquisaConsumoProdutoFlows = new PesquisaConsumoProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        pesquisaConsumoProdutoFlows.navegateTelaConsumoConsumoProduto();
        pesquisaConsumoProdutoPage.camposObrigatorios();
        pesquisaConsumoProdutoPage.refresh();
        pesquisaConsumoProdutoPage.obrigatorioTipoConsumo();
    }


}