package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PrevisaoDeConsumoFlows;
import com.javaseleniumtemplate.pages.PrevisaoDeConsumoPage;
import org.testng.annotations.Test;

public class PrevisaoDeConsumoTests extends TestBase {

    PrevisaoDeConsumoPage previsaoDeConsumoPage;
    PrevisaoDeConsumoFlows previsaoDeConsumoFlows;
    LoginFlows loginFlows;

    public void emitirRelatorioPrevisaoConsumo(String nomeRelatorio){
        loginFlows = new LoginFlows();
        previsaoDeConsumoFlows = new PrevisaoDeConsumoFlows();
        String DTINICIAL = "01/10/2023";
        String DTFINAL = "31/10/2023";
        String CDFILIAl = "0002";
        String CDSERVICO = "00002";
        String QTDACRESCIMO = "20";

        loginFlows.efetuarLogin();
        previsaoDeConsumoFlows.acessarTelaPrevisaoDeConsumo();
        previsaoDeConsumoFlows.selecionarRelatorios(nomeRelatorio);
        previsaoDeConsumoFlows.selecionarPeriodo(DTINICIAL,DTFINAL);
        previsaoDeConsumoFlows.selecionarUnidades(CDFILIAl);
        previsaoDeConsumoFlows.selecionaServico(CDSERVICO);

        if (nomeRelatorio == "Previsão de Consumo - Consolidado - Particularidades"){
            previsaoDeConsumoFlows.emitirRelatorio(QTDACRESCIMO);
            previsaoDeConsumoFlows.validarUrlGeradaFecharAba(nomeRelatorio);
            previsaoDeConsumoFlows.alteraFiltroRelatorio();
            previsaoDeConsumoFlows.validarUrlGeradaFecharAba(nomeRelatorio);
        }else{
            previsaoDeConsumoFlows.definirNivelProduto();
            previsaoDeConsumoFlows.emitirRelatorio(QTDACRESCIMO);
            previsaoDeConsumoFlows.validarUrlGeradaFecharAba(nomeRelatorio);
            previsaoDeConsumoFlows.alteraFiltroRelatorio();
            previsaoDeConsumoFlows.validarUrlGeradaFecharAba(nomeRelatorio);
        }
    }


    @Test
    public void previsaoTotalPeriodo(){
    emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Total do Período)");
    }

    @Test
    public void PrevisaoConsumoTotalPeriodoCusto(){
    emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Total do Período com Custo)");
    }

    @Test
    public void PrevisaoConsumoDataProduto(){
    emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Data por Produto)");
    }

    @Test
    public void PrevisaoConsumoDataPorProdutoComCusto(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Data por Produto com Custo)");
    }

    @Test
    public void PrevisaoConsumoProdutoPorData(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Produto por Data)");
    }

    @Test
    public void PrevisaoConsumoProdutoPorDataComCusto(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Produto por Data com Custo)");
    }

    @Test
    public void PrevisaoConsumoConsolidado(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo - Consolidado");
    }

    @Test
    public void PrevisaoConsumoConsolidadoParticularidade(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo - Consolidado - Particularidades");
    }

    @Test
    public void PrevisaoConsumoPorPratoComCusto(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo (por Prato / com Custo)");
    }

    @Test
    public void PrevisaoConsumoUnidadePorProduto(){
        emitirRelatorioPrevisaoConsumo("Previsão de Consumo (Unidade por Produto)");
    }








}
